SDL_render.h File Reference
`#include <SDL3/SDL_stdinc.h>`
`#include <SDL3/SDL_blendmode.h>`
`#include <SDL3/SDL_error.h>`
`#include <SDL3/SDL_events.h>`
`#include <SDL3/SDL_pixels.h>`
`#include <SDL3/SDL_properties.h>`
`#include <SDL3/SDL_rect.h>`
`#include <SDL3/SDL_surface.h>`
`#include <SDL3/SDL_video.h>`
`#include <SDL3/SDL_begin_code.h>`
`#include <SDL3/SDL_close_code.h>`
Include dependency graph for SDL_render.h:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Data Structures

struct | SDL_Vertex
struct | SDL_Texture

## Macros

#define | SDL_SOFTWARE_RENDERER "software"
#define | SDL_PROP_RENDERER_CREATE_NAME_STRING "SDL.renderer.create.name"
#define | SDL_PROP_RENDERER_CREATE_WINDOW_POINTER "SDL.renderer.create.window"
#define | SDL_PROP_RENDERER_CREATE_SURFACE_POINTER "SDL.renderer.create.surface"
#define | SDL_PROP_RENDERER_CREATE_OUTPUT_COLORSPACE_NUMBER "SDL.renderer.create.output_colorspace"
#define | SDL_PROP_RENDERER_CREATE_PRESENT_VSYNC_NUMBER "SDL.renderer.create.present_vsync"
#define | SDL_PROP_RENDERER_CREATE_VULKAN_INSTANCE_POINTER "SDL.renderer.create.vulkan.instance"
#define | SDL_PROP_RENDERER_CREATE_VULKAN_SURFACE_NUMBER "SDL.renderer.create.vulkan.surface"
#define | SDL_PROP_RENDERER_CREATE_VULKAN_PHYSICAL_DEVICE_POINTER "SDL.renderer.create.vulkan.physical_device"
#define | SDL_PROP_RENDERER_CREATE_VULKAN_DEVICE_POINTER "SDL.renderer.create.vulkan.device"
#define | SDL_PROP_RENDERER_CREATE_VULKAN_GRAPHICS_QUEUE_FAMILY_INDEX_NUMBER "SDL.renderer.create.vulkan.graphics_queue_family_index"
#define | SDL_PROP_RENDERER_CREATE_VULKAN_PRESENT_QUEUE_FAMILY_INDEX_NUMBER "SDL.renderer.create.vulkan.present_queue_family_index"
#define | SDL_PROP_RENDERER_NAME_STRING "SDL.renderer.name"
#define | SDL_PROP_RENDERER_WINDOW_POINTER "SDL.renderer.window"
#define | SDL_PROP_RENDERER_SURFACE_POINTER "SDL.renderer.surface"
#define | SDL_PROP_RENDERER_VSYNC_NUMBER "SDL.renderer.vsync"
#define | SDL_PROP_RENDERER_MAX_TEXTURE_SIZE_NUMBER "SDL.renderer.max_texture_size"
#define | SDL_PROP_RENDERER_TEXTURE_FORMATS_POINTER "SDL.renderer.texture_formats"
#define | SDL_PROP_RENDERER_OUTPUT_COLORSPACE_NUMBER "SDL.renderer.output_colorspace"
#define | SDL_PROP_RENDERER_HDR_ENABLED_BOOLEAN "SDL.renderer.HDR_enabled"
#define | SDL_PROP_RENDERER_SDR_WHITE_POINT_FLOAT "SDL.renderer.SDR_white_point"
#define | SDL_PROP_RENDERER_HDR_HEADROOM_FLOAT "SDL.renderer.HDR_headroom"
#define | SDL_PROP_RENDERER_D3D9_DEVICE_POINTER "SDL.renderer.d3d9.device"
#define | SDL_PROP_RENDERER_D3D11_DEVICE_POINTER "SDL.renderer.d3d11.device"
#define | SDL_PROP_RENDERER_D3D11_SWAPCHAIN_POINTER "SDL.renderer.d3d11.swap_chain"
#define | SDL_PROP_RENDERER_D3D12_DEVICE_POINTER "SDL.renderer.d3d12.device"
#define | SDL_PROP_RENDERER_D3D12_SWAPCHAIN_POINTER "SDL.renderer.d3d12.swap_chain"
#define | SDL_PROP_RENDERER_D3D12_COMMAND_QUEUE_POINTER "SDL.renderer.d3d12.command_queue"
#define | SDL_PROP_RENDERER_VULKAN_INSTANCE_POINTER "SDL.renderer.vulkan.instance"
#define | SDL_PROP_RENDERER_VULKAN_SURFACE_NUMBER "SDL.renderer.vulkan.surface"
#define | SDL_PROP_RENDERER_VULKAN_PHYSICAL_DEVICE_POINTER "SDL.renderer.vulkan.physical_device"
#define | SDL_PROP_RENDERER_VULKAN_DEVICE_POINTER "SDL.renderer.vulkan.device"
#define | SDL_PROP_RENDERER_VULKAN_GRAPHICS_QUEUE_FAMILY_INDEX_NUMBER "SDL.renderer.vulkan.graphics_queue_family_index"
#define | SDL_PROP_RENDERER_VULKAN_PRESENT_QUEUE_FAMILY_INDEX_NUMBER "SDL.renderer.vulkan.present_queue_family_index"
#define | SDL_PROP_RENDERER_VULKAN_SWAPCHAIN_IMAGE_COUNT_NUMBER "SDL.renderer.vulkan.swapchain_image_count"
#define | SDL_PROP_RENDERER_GPU_DEVICE_POINTER "SDL.renderer.gpu.device"
#define | SDL_PROP_TEXTURE_CREATE_COLORSPACE_NUMBER "SDL.texture.create.colorspace"
#define | SDL_PROP_TEXTURE_CREATE_FORMAT_NUMBER "SDL.texture.create.format"
#define | SDL_PROP_TEXTURE_CREATE_ACCESS_NUMBER "SDL.texture.create.access"
#define | SDL_PROP_TEXTURE_CREATE_WIDTH_NUMBER "SDL.texture.create.width"
#define | SDL_PROP_TEXTURE_CREATE_HEIGHT_NUMBER "SDL.texture.create.height"
#define | SDL_PROP_TEXTURE_CREATE_SDR_WHITE_POINT_FLOAT "SDL.texture.create.SDR_white_point"
#define | SDL_PROP_TEXTURE_CREATE_HDR_HEADROOM_FLOAT "SDL.texture.create.HDR_headroom"
#define | SDL_PROP_TEXTURE_CREATE_D3D11_TEXTURE_POINTER "SDL.texture.create.d3d11.texture"
#define | SDL_PROP_TEXTURE_CREATE_D3D11_TEXTURE_U_POINTER "SDL.texture.create.d3d11.texture_u"
#define | SDL_PROP_TEXTURE_CREATE_D3D11_TEXTURE_V_POINTER "SDL.texture.create.d3d11.texture_v"
#define | SDL_PROP_TEXTURE_CREATE_D3D12_TEXTURE_POINTER "SDL.texture.create.d3d12.texture"
#define | SDL_PROP_TEXTURE_CREATE_D3D12_TEXTURE_U_POINTER "SDL.texture.create.d3d12.texture_u"
#define | SDL_PROP_TEXTURE_CREATE_D3D12_TEXTURE_V_POINTER "SDL.texture.create.d3d12.texture_v"
#define | SDL_PROP_TEXTURE_CREATE_METAL_PIXELBUFFER_POINTER "SDL.texture.create.metal.pixelbuffer"
#define | SDL_PROP_TEXTURE_CREATE_OPENGL_TEXTURE_NUMBER "SDL.texture.create.opengl.texture"
#define | SDL_PROP_TEXTURE_CREATE_OPENGL_TEXTURE_UV_NUMBER "SDL.texture.create.opengl.texture_uv"
#define | SDL_PROP_TEXTURE_CREATE_OPENGL_TEXTURE_U_NUMBER "SDL.texture.create.opengl.texture_u"
#define | SDL_PROP_TEXTURE_CREATE_OPENGL_TEXTURE_V_NUMBER "SDL.texture.create.opengl.texture_v"
#define | SDL_PROP_TEXTURE_CREATE_OPENGLES2_TEXTURE_NUMBER "SDL.texture.create.opengles2.texture"
#define | SDL_PROP_TEXTURE_CREATE_OPENGLES2_TEXTURE_UV_NUMBER "SDL.texture.create.opengles2.texture_uv"
#define | SDL_PROP_TEXTURE_CREATE_OPENGLES2_TEXTURE_U_NUMBER "SDL.texture.create.opengles2.texture_u"
#define | SDL_PROP_TEXTURE_CREATE_OPENGLES2_TEXTURE_V_NUMBER "SDL.texture.create.opengles2.texture_v"
#define | SDL_PROP_TEXTURE_CREATE_VULKAN_TEXTURE_NUMBER "SDL.texture.create.vulkan.texture"
#define | SDL_PROP_TEXTURE_COLORSPACE_NUMBER "SDL.texture.colorspace"
#define | SDL_PROP_TEXTURE_FORMAT_NUMBER "SDL.texture.format"
#define | SDL_PROP_TEXTURE_ACCESS_NUMBER "SDL.texture.access"
#define | SDL_PROP_TEXTURE_WIDTH_NUMBER "SDL.texture.width"
#define | SDL_PROP_TEXTURE_HEIGHT_NUMBER "SDL.texture.height"
#define | SDL_PROP_TEXTURE_SDR_WHITE_POINT_FLOAT "SDL.texture.SDR_white_point"
#define | SDL_PROP_TEXTURE_HDR_HEADROOM_FLOAT "SDL.texture.HDR_headroom"
#define | SDL_PROP_TEXTURE_D3D11_TEXTURE_POINTER "SDL.texture.d3d11.texture"
#define | SDL_PROP_TEXTURE_D3D11_TEXTURE_U_POINTER "SDL.texture.d3d11.texture_u"
#define | SDL_PROP_TEXTURE_D3D11_TEXTURE_V_POINTER "SDL.texture.d3d11.texture_v"
#define | SDL_PROP_TEXTURE_D3D12_TEXTURE_POINTER "SDL.texture.d3d12.texture"
#define | SDL_PROP_TEXTURE_D3D12_TEXTURE_U_POINTER "SDL.texture.d3d12.texture_u"
#define | SDL_PROP_TEXTURE_D3D12_TEXTURE_V_POINTER "SDL.texture.d3d12.texture_v"
#define | SDL_PROP_TEXTURE_OPENGL_TEXTURE_NUMBER "SDL.texture.opengl.texture"
#define | SDL_PROP_TEXTURE_OPENGL_TEXTURE_UV_NUMBER "SDL.texture.opengl.texture_uv"
#define | SDL_PROP_TEXTURE_OPENGL_TEXTURE_U_NUMBER "SDL.texture.opengl.texture_u"
#define | SDL_PROP_TEXTURE_OPENGL_TEXTURE_V_NUMBER "SDL.texture.opengl.texture_v"
#define | SDL_PROP_TEXTURE_OPENGL_TEXTURE_TARGET_NUMBER "SDL.texture.opengl.target"
#define | SDL_PROP_TEXTURE_OPENGL_TEX_W_FLOAT "SDL.texture.opengl.tex_w"
#define | SDL_PROP_TEXTURE_OPENGL_TEX_H_FLOAT "SDL.texture.opengl.tex_h"
#define | SDL_PROP_TEXTURE_OPENGLES2_TEXTURE_NUMBER "SDL.texture.opengles2.texture"
#define | SDL_PROP_TEXTURE_OPENGLES2_TEXTURE_UV_NUMBER "SDL.texture.opengles2.texture_uv"
#define | SDL_PROP_TEXTURE_OPENGLES2_TEXTURE_U_NUMBER "SDL.texture.opengles2.texture_u"
#define | SDL_PROP_TEXTURE_OPENGLES2_TEXTURE_V_NUMBER "SDL.texture.opengles2.texture_v"
#define | SDL_PROP_TEXTURE_OPENGLES2_TEXTURE_TARGET_NUMBER "SDL.texture.opengles2.target"
#define | SDL_PROP_TEXTURE_VULKAN_TEXTURE_NUMBER "SDL.texture.vulkan.texture"
#define | SDL_RENDERER_VSYNC_DISABLED 0
#define | SDL_RENDERER_VSYNC_ADAPTIVE (-1)
#define | SDL_DEBUG_TEXT_FONT_CHARACTER_SIZE 8

## Typedefs

typedef struct SDL_Renderer | SDL_Renderer

## Enumerations

enum | SDL_TextureAccess { SDL_TEXTUREACCESS_STATIC , SDL_TEXTUREACCESS_STREAMING , SDL_TEXTUREACCESS_TARGET }
enum | SDL_RendererLogicalPresentation { SDL_LOGICAL_PRESENTATION_DISABLED , SDL_LOGICAL_PRESENTATION_STRETCH , SDL_LOGICAL_PRESENTATION_LETTERBOX , SDL_LOGICAL_PRESENTATION_OVERSCAN , SDL_LOGICAL_PRESENTATION_INTEGER_SCALE }

## Functions

int | SDL_GetNumRenderDrivers (void)
const char * | SDL_GetRenderDriver (int index)
bool | SDL_CreateWindowAndRenderer (const char *title, int width, int height, SDL_WindowFlags window_flags, SDL_Window **window, SDL_Renderer **renderer)
SDL_Renderer * | SDL_CreateRenderer (SDL_Window *window, const char *name)
SDL_Renderer * | SDL_CreateRendererWithProperties (SDL_PropertiesID props)
SDL_Renderer * | SDL_CreateSoftwareRenderer (SDL_Surface *surface)
SDL_Renderer * | SDL_GetRenderer (SDL_Window *window)
SDL_Window * | SDL_GetRenderWindow (SDL_Renderer *renderer)
const char * | SDL_GetRendererName (SDL_Renderer *renderer)
SDL_PropertiesID | SDL_GetRendererProperties (SDL_Renderer *renderer)
bool | SDL_GetRenderOutputSize (SDL_Renderer *renderer, int *w, int *h)
bool | SDL_GetCurrentRenderOutputSize (SDL_Renderer *renderer, int *w, int *h)
SDL_Texture * | SDL_CreateTexture (SDL_Renderer *renderer, SDL_PixelFormat format, SDL_TextureAccess access, int w, int h)
SDL_Texture * | SDL_CreateTextureFromSurface (SDL_Renderer *renderer, SDL_Surface *surface)
SDL_Texture * | SDL_CreateTextureWithProperties (SDL_Renderer *renderer, SDL_PropertiesID props)
SDL_PropertiesID | SDL_GetTextureProperties (SDL_Texture *texture)
SDL_Renderer * | SDL_GetRendererFromTexture (SDL_Texture *texture)
bool | SDL_GetTextureSize (SDL_Texture *texture, float *w, float *h)
bool | SDL_SetTextureColorMod (SDL_Texture *texture, Uint8 r, Uint8 g, Uint8 b)
bool | SDL_SetTextureColorModFloat (SDL_Texture *texture, float r, float g, float b)
bool | SDL_GetTextureColorMod (SDL_Texture *texture, Uint8 *r, Uint8 *g, Uint8 *b)
bool | SDL_GetTextureColorModFloat (SDL_Texture *texture, float *r, float *g, float *b)
bool | SDL_SetTextureAlphaMod (SDL_Texture *texture, Uint8 alpha)
bool | SDL_SetTextureAlphaModFloat (SDL_Texture *texture, float alpha)
bool | SDL_GetTextureAlphaMod (SDL_Texture *texture, Uint8 *alpha)
bool | SDL_GetTextureAlphaModFloat (SDL_Texture *texture, float *alpha)
bool | SDL_SetTextureBlendMode (SDL_Texture *texture, SDL_BlendMode blendMode)
bool | SDL_GetTextureBlendMode (SDL_Texture *texture, SDL_BlendMode *blendMode)
bool | SDL_SetTextureScaleMode (SDL_Texture *texture, SDL_ScaleMode scaleMode)
bool | SDL_GetTextureScaleMode (SDL_Texture *texture, SDL_ScaleMode *scaleMode)
bool | SDL_UpdateTexture (SDL_Texture *texture, const SDL_Rect *rect, const void *pixels, int pitch)
bool | SDL_UpdateYUVTexture (SDL_Texture *texture, const SDL_Rect *rect, const Uint8 *Yplane, int Ypitch, const Uint8 *Uplane, int Upitch, const Uint8 *Vplane, int Vpitch)
bool | SDL_UpdateNVTexture (SDL_Texture *texture, const SDL_Rect *rect, const Uint8 *Yplane, int Ypitch, const Uint8 *UVplane, int UVpitch)
bool | SDL_LockTexture (SDL_Texture *texture, const SDL_Rect *rect, void **pixels, int *pitch)
bool | SDL_LockTextureToSurface (SDL_Texture *texture, const SDL_Rect *rect, SDL_Surface **surface)
void | SDL_UnlockTexture (SDL_Texture *texture)
bool | SDL_SetRenderTarget (SDL_Renderer *renderer, SDL_Texture *texture)
SDL_Texture * | SDL_GetRenderTarget (SDL_Renderer *renderer)
bool | SDL_SetRenderLogicalPresentation (SDL_Renderer *renderer, int w, int h, SDL_RendererLogicalPresentation mode)
bool | SDL_GetRenderLogicalPresentation (SDL_Renderer *renderer, int *w, int *h, SDL_RendererLogicalPresentation *mode)
bool | SDL_GetRenderLogicalPresentationRect (SDL_Renderer *renderer, SDL_FRect *rect)
bool | SDL_RenderCoordinatesFromWindow (SDL_Renderer *renderer, float window_x, float window_y, float *x, float *y)
bool | SDL_RenderCoordinatesToWindow (SDL_Renderer *renderer, float x, float y, float *window_x, float *window_y)
bool | SDL_ConvertEventToRenderCoordinates (SDL_Renderer *renderer, SDL_Event *event)
bool | SDL_SetRenderViewport (SDL_Renderer *renderer, const SDL_Rect *rect)
bool | SDL_GetRenderViewport (SDL_Renderer *renderer, SDL_Rect *rect)
bool | SDL_RenderViewportSet (SDL_Renderer *renderer)
bool | SDL_GetRenderSafeArea (SDL_Renderer *renderer, SDL_Rect *rect)
bool | SDL_SetRenderClipRect (SDL_Renderer *renderer, const SDL_Rect *rect)
bool | SDL_GetRenderClipRect (SDL_Renderer *renderer, SDL_Rect *rect)
bool | SDL_RenderClipEnabled (SDL_Renderer *renderer)
bool | SDL_SetRenderScale (SDL_Renderer *renderer, float scaleX, float scaleY)
bool | SDL_GetRenderScale (SDL_Renderer *renderer, float *scaleX, float *scaleY)
bool | SDL_SetRenderDrawColor (SDL_Renderer *renderer, Uint8 r, Uint8 g, Uint8 b, Uint8 a)
bool | SDL_SetRenderDrawColorFloat (SDL_Renderer *renderer, float r, float g, float b, float a)
bool | SDL_GetRenderDrawColor (SDL_Renderer *renderer, Uint8 *r, Uint8 *g, Uint8 *b, Uint8 *a)
bool | SDL_GetRenderDrawColorFloat (SDL_Renderer *renderer, float *r, float *g, float *b, float *a)
bool | SDL_SetRenderColorScale (SDL_Renderer *renderer, float scale)
bool | SDL_GetRenderColorScale (SDL_Renderer *renderer, float *scale)
bool | SDL_SetRenderDrawBlendMode (SDL_Renderer *renderer, SDL_BlendMode blendMode)
bool | SDL_GetRenderDrawBlendMode (SDL_Renderer *renderer, SDL_BlendMode *blendMode)
bool | SDL_RenderClear (SDL_Renderer *renderer)
bool | SDL_RenderPoint (SDL_Renderer *renderer, float x, float y)
bool | SDL_RenderPoints (SDL_Renderer *renderer, const SDL_FPoint *points, int count)
bool | SDL_RenderLine (SDL_Renderer *renderer, float x1, float y1, float x2, float y2)
bool | SDL_RenderLines (SDL_Renderer *renderer, const SDL_FPoint *points, int count)
bool | SDL_RenderRect (SDL_Renderer *renderer, const SDL_FRect *rect)
bool | SDL_RenderRects (SDL_Renderer *renderer, const SDL_FRect *rects, int count)
bool | SDL_RenderFillRect (SDL_Renderer *renderer, const SDL_FRect *rect)
bool | SDL_RenderFillRects (SDL_Renderer *renderer, const SDL_FRect *rects, int count)
bool | SDL_RenderTexture (SDL_Renderer *renderer, SDL_Texture *texture, const SDL_FRect *srcrect, const SDL_FRect *dstrect)
bool | SDL_RenderTextureRotated (SDL_Renderer *renderer, SDL_Texture *texture, const SDL_FRect *srcrect, const SDL_FRect *dstrect, double angle, const SDL_FPoint *center, SDL_FlipMode flip)
bool | SDL_RenderTextureAffine (SDL_Renderer *renderer, SDL_Texture *texture, const SDL_FRect *srcrect, const SDL_FPoint *origin, const SDL_FPoint *right, const SDL_FPoint *down)
bool | SDL_RenderTextureTiled (SDL_Renderer *renderer, SDL_Texture *texture, const SDL_FRect *srcrect, float scale, const SDL_FRect *dstrect)
bool | SDL_RenderTexture9Grid (SDL_Renderer *renderer, SDL_Texture *texture, const SDL_FRect *srcrect, float left_width, float right_width, float top_height, float bottom_height, float scale, const SDL_FRect *dstrect)
bool | SDL_RenderGeometry (SDL_Renderer *renderer, SDL_Texture *texture, const SDL_Vertex *vertices, int num_vertices, const int *indices, int num_indices)
bool | SDL_RenderGeometryRaw (SDL_Renderer *renderer, SDL_Texture *texture, const float *xy, int xy_stride, const SDL_FColor *color, int color_stride, const float *uv, int uv_stride, int num_vertices, const void *indices, int num_indices, int size_indices)
SDL_Surface * | SDL_RenderReadPixels (SDL_Renderer *renderer, const SDL_Rect *rect)
bool | SDL_RenderPresent (SDL_Renderer *renderer)
void | SDL_DestroyTexture (SDL_Texture *texture)
void | SDL_DestroyRenderer (SDL_Renderer *renderer)
bool | SDL_FlushRenderer (SDL_Renderer *renderer)
void * | SDL_GetRenderMetalLayer (SDL_Renderer *renderer)
void * | SDL_GetRenderMetalCommandEncoder (SDL_Renderer *renderer)
bool | SDL_AddVulkanRenderSemaphores (SDL_Renderer *renderer, Uint32 wait_stage_mask, Sint64 wait_semaphore, Sint64 signal_semaphore)
bool | SDL_SetRenderVSync (SDL_Renderer *renderer, int vsync)
bool | SDL_GetRenderVSync (SDL_Renderer *renderer, int *vsync)
bool | SDL_RenderDebugText (SDL_Renderer *renderer, float x, float y, const char *str)
bool | SDL_RenderDebugTextFormat (SDL_Renderer *renderer, float x, float y, SDL_PRINTF_FORMAT_STRING const char *fmt,...) SDL_PRINTF_VARARG_FUNC(4)

## Macro Definition Documentation

## SDL_DEBUG_TEXT_FONT_CHARACTER_SIZE

#define SDL_DEBUG_TEXT_FONT_CHARACTER_SIZE 8

The size, in pixels, of a single SDL_RenderDebugText() character.

The font is monospaced and square, so this applies to all characters.

Since
  This macro is available since SDL 3.2.0.

See also
  SDL_RenderDebugText

Definition at line 2568 of file SDL_render.h.

## SDL_PROP_RENDERER_CREATE_NAME_STRING

#define SDL_PROP_RENDERER_CREATE_NAME_STRING "SDL.renderer.create.name"

Definition at line 301 of file SDL_render.h.

## SDL_PROP_RENDERER_CREATE_OUTPUT_COLORSPACE_NUMBER

#define SDL_PROP_RENDERER_CREATE_OUTPUT_COLORSPACE_NUMBER "SDL.renderer.create.output_colorspace"

Definition at line 304 of file SDL_render.h.

## SDL_PROP_RENDERER_CREATE_PRESENT_VSYNC_NUMBER

#define SDL_PROP_RENDERER_CREATE_PRESENT_VSYNC_NUMBER "SDL.renderer.create.present_vsync"

Definition at line 305 of file SDL_render.h.

## SDL_PROP_RENDERER_CREATE_SURFACE_POINTER

#define SDL_PROP_RENDERER_CREATE_SURFACE_POINTER "SDL.renderer.create.surface"

Definition at line 303 of file SDL_render.h.

## SDL_PROP_RENDERER_CREATE_VULKAN_DEVICE_POINTER

#define SDL_PROP_RENDERER_CREATE_VULKAN_DEVICE_POINTER "SDL.renderer.create.vulkan.device"

Definition at line 309 of file SDL_render.h.

## SDL_PROP_RENDERER_CREATE_VULKAN_GRAPHICS_QUEUE_FAMILY_INDEX_NUMBER

#define SDL_PROP_RENDERER_CREATE_VULKAN_GRAPHICS_QUEUE_FAMILY_INDEX_NUMBER "SDL.renderer.create.vulkan.graphics_queue_family_index"

Definition at line 310 of file SDL_render.h.

## SDL_PROP_RENDERER_CREATE_VULKAN_INSTANCE_POINTER

#define SDL_PROP_RENDERER_CREATE_VULKAN_INSTANCE_POINTER "SDL.renderer.create.vulkan.instance"

Definition at line 306 of file SDL_render.h.

## SDL_PROP_RENDERER_CREATE_VULKAN_PHYSICAL_DEVICE_POINTER

#define SDL_PROP_RENDERER_CREATE_VULKAN_PHYSICAL_DEVICE_POINTER "SDL.renderer.create.vulkan.physical_device"

Definition at line 308 of file SDL_render.h.

## SDL_PROP_RENDERER_CREATE_VULKAN_PRESENT_QUEUE_FAMILY_INDEX_NUMBER

#define SDL_PROP_RENDERER_CREATE_VULKAN_PRESENT_QUEUE_FAMILY_INDEX_NUMBER "SDL.renderer.create.vulkan.present_queue_family_index"

Definition at line 311 of file SDL_render.h.

## SDL_PROP_RENDERER_CREATE_VULKAN_SURFACE_NUMBER

#define SDL_PROP_RENDERER_CREATE_VULKAN_SURFACE_NUMBER "SDL.renderer.create.vulkan.surface"

Definition at line 307 of file SDL_render.h.

## SDL_PROP_RENDERER_CREATE_WINDOW_POINTER

#define SDL_PROP_RENDERER_CREATE_WINDOW_POINTER "SDL.renderer.create.window"

Definition at line 302 of file SDL_render.h.

## SDL_PROP_RENDERER_D3D11_DEVICE_POINTER

#define SDL_PROP_RENDERER_D3D11_DEVICE_POINTER "SDL.renderer.d3d11.device"

Definition at line 473 of file SDL_render.h.

## SDL_PROP_RENDERER_D3D11_SWAPCHAIN_POINTER

#define SDL_PROP_RENDERER_D3D11_SWAPCHAIN_POINTER "SDL.renderer.d3d11.swap_chain"

Definition at line 474 of file SDL_render.h.

## SDL_PROP_RENDERER_D3D12_COMMAND_QUEUE_POINTER

#define SDL_PROP_RENDERER_D3D12_COMMAND_QUEUE_POINTER "SDL.renderer.d3d12.command_queue"

Definition at line 477 of file SDL_render.h.

## SDL_PROP_RENDERER_D3D12_DEVICE_POINTER

#define SDL_PROP_RENDERER_D3D12_DEVICE_POINTER "SDL.renderer.d3d12.device"

Definition at line 475 of file SDL_render.h.

## SDL_PROP_RENDERER_D3D12_SWAPCHAIN_POINTER

#define SDL_PROP_RENDERER_D3D12_SWAPCHAIN_POINTER "SDL.renderer.d3d12.swap_chain"

Definition at line 476 of file SDL_render.h.

## SDL_PROP_RENDERER_D3D9_DEVICE_POINTER

#define SDL_PROP_RENDERER_D3D9_DEVICE_POINTER "SDL.renderer.d3d9.device"

Definition at line 472 of file SDL_render.h.

## SDL_PROP_RENDERER_GPU_DEVICE_POINTER

#define SDL_PROP_RENDERER_GPU_DEVICE_POINTER "SDL.renderer.gpu.device"

Definition at line 485 of file SDL_render.h.

## SDL_PROP_RENDERER_HDR_ENABLED_BOOLEAN

#define SDL_PROP_RENDERER_HDR_ENABLED_BOOLEAN "SDL.renderer.HDR_enabled"

Definition at line 469 of file SDL_render.h.

## SDL_PROP_RENDERER_HDR_HEADROOM_FLOAT

#define SDL_PROP_RENDERER_HDR_HEADROOM_FLOAT "SDL.renderer.HDR_headroom"

Definition at line 471 of file SDL_render.h.

## SDL_PROP_RENDERER_MAX_TEXTURE_SIZE_NUMBER

#define SDL_PROP_RENDERER_MAX_TEXTURE_SIZE_NUMBER "SDL.renderer.max_texture_size"

Definition at line 466 of file SDL_render.h.

## SDL_PROP_RENDERER_NAME_STRING

#define SDL_PROP_RENDERER_NAME_STRING "SDL.renderer.name"

Definition at line 462 of file SDL_render.h.

## SDL_PROP_RENDERER_OUTPUT_COLORSPACE_NUMBER

#define SDL_PROP_RENDERER_OUTPUT_COLORSPACE_NUMBER "SDL.renderer.output_colorspace"

Definition at line 468 of file SDL_render.h.

## SDL_PROP_RENDERER_SDR_WHITE_POINT_FLOAT

#define SDL_PROP_RENDERER_SDR_WHITE_POINT_FLOAT "SDL.renderer.SDR_white_point"

Definition at line 470 of file SDL_render.h.

## SDL_PROP_RENDERER_SURFACE_POINTER

#define SDL_PROP_RENDERER_SURFACE_POINTER "SDL.renderer.surface"

Definition at line 464 of file SDL_render.h.

## SDL_PROP_RENDERER_TEXTURE_FORMATS_POINTER

#define SDL_PROP_RENDERER_TEXTURE_FORMATS_POINTER "SDL.renderer.texture_formats"

Definition at line 467 of file SDL_render.h.

## SDL_PROP_RENDERER_VSYNC_NUMBER

#define SDL_PROP_RENDERER_VSYNC_NUMBER "SDL.renderer.vsync"

Definition at line 465 of file SDL_render.h.

## SDL_PROP_RENDERER_VULKAN_DEVICE_POINTER

#define SDL_PROP_RENDERER_VULKAN_DEVICE_POINTER "SDL.renderer.vulkan.device"

Definition at line 481 of file SDL_render.h.

## SDL_PROP_RENDERER_VULKAN_GRAPHICS_QUEUE_FAMILY_INDEX_NUMBER

#define SDL_PROP_RENDERER_VULKAN_GRAPHICS_QUEUE_FAMILY_INDEX_NUMBER "SDL.renderer.vulkan.graphics_queue_family_index"

Definition at line 482 of file SDL_render.h.

## SDL_PROP_RENDERER_VULKAN_INSTANCE_POINTER

#define SDL_PROP_RENDERER_VULKAN_INSTANCE_POINTER "SDL.renderer.vulkan.instance"

Definition at line 478 of file SDL_render.h.

## SDL_PROP_RENDERER_VULKAN_PHYSICAL_DEVICE_POINTER

#define SDL_PROP_RENDERER_VULKAN_PHYSICAL_DEVICE_POINTER "SDL.renderer.vulkan.physical_device"

Definition at line 480 of file SDL_render.h.

## SDL_PROP_RENDERER_VULKAN_PRESENT_QUEUE_FAMILY_INDEX_NUMBER

#define SDL_PROP_RENDERER_VULKAN_PRESENT_QUEUE_FAMILY_INDEX_NUMBER "SDL.renderer.vulkan.present_queue_family_index"

Definition at line 483 of file SDL_render.h.

## SDL_PROP_RENDERER_VULKAN_SURFACE_NUMBER

#define SDL_PROP_RENDERER_VULKAN_SURFACE_NUMBER "SDL.renderer.vulkan.surface"

Definition at line 479 of file SDL_render.h.

## SDL_PROP_RENDERER_VULKAN_SWAPCHAIN_IMAGE_COUNT_NUMBER

#define SDL_PROP_RENDERER_VULKAN_SWAPCHAIN_IMAGE_COUNT_NUMBER "SDL.renderer.vulkan.swapchain_image_count"

Definition at line 484 of file SDL_render.h.

## SDL_PROP_RENDERER_WINDOW_POINTER

#define SDL_PROP_RENDERER_WINDOW_POINTER "SDL.renderer.window"

Definition at line 463 of file SDL_render.h.

## SDL_PROP_TEXTURE_ACCESS_NUMBER

#define SDL_PROP_TEXTURE_ACCESS_NUMBER "SDL.texture.access"

Definition at line 812 of file SDL_render.h.

## SDL_PROP_TEXTURE_COLORSPACE_NUMBER

#define SDL_PROP_TEXTURE_COLORSPACE_NUMBER "SDL.texture.colorspace"

Definition at line 810 of file SDL_render.h.

## SDL_PROP_TEXTURE_CREATE_ACCESS_NUMBER

#define SDL_PROP_TEXTURE_CREATE_ACCESS_NUMBER "SDL.texture.create.access"

Definition at line 700 of file SDL_render.h.

## SDL_PROP_TEXTURE_CREATE_COLORSPACE_NUMBER

#define SDL_PROP_TEXTURE_CREATE_COLORSPACE_NUMBER "SDL.texture.create.colorspace"

Definition at line 698 of file SDL_render.h.

## SDL_PROP_TEXTURE_CREATE_D3D11_TEXTURE_POINTER

#define SDL_PROP_TEXTURE_CREATE_D3D11_TEXTURE_POINTER "SDL.texture.create.d3d11.texture"

Definition at line 705 of file SDL_render.h.

## SDL_PROP_TEXTURE_CREATE_D3D11_TEXTURE_U_POINTER

#define SDL_PROP_TEXTURE_CREATE_D3D11_TEXTURE_U_POINTER "SDL.texture.create.d3d11.texture_u"

Definition at line 706 of file SDL_render.h.

## SDL_PROP_TEXTURE_CREATE_D3D11_TEXTURE_V_POINTER

#define SDL_PROP_TEXTURE_CREATE_D3D11_TEXTURE_V_POINTER "SDL.texture.create.d3d11.texture_v"

Definition at line 707 of file SDL_render.h.

## SDL_PROP_TEXTURE_CREATE_D3D12_TEXTURE_POINTER

#define SDL_PROP_TEXTURE_CREATE_D3D12_TEXTURE_POINTER "SDL.texture.create.d3d12.texture"

Definition at line 708 of file SDL_render.h.

## SDL_PROP_TEXTURE_CREATE_D3D12_TEXTURE_U_POINTER

#define SDL_PROP_TEXTURE_CREATE_D3D12_TEXTURE_U_POINTER "SDL.texture.create.d3d12.texture_u"

Definition at line 709 of file SDL_render.h.

## SDL_PROP_TEXTURE_CREATE_D3D12_TEXTURE_V_POINTER

#define SDL_PROP_TEXTURE_CREATE_D3D12_TEXTURE_V_POINTER "SDL.texture.create.d3d12.texture_v"

Definition at line 710 of file SDL_render.h.

## SDL_PROP_TEXTURE_CREATE_FORMAT_NUMBER

#define SDL_PROP_TEXTURE_CREATE_FORMAT_NUMBER "SDL.texture.create.format"

Definition at line 699 of file SDL_render.h.

## SDL_PROP_TEXTURE_CREATE_HDR_HEADROOM_FLOAT

#define SDL_PROP_TEXTURE_CREATE_HDR_HEADROOM_FLOAT "SDL.texture.create.HDR_headroom"

Definition at line 704 of file SDL_render.h.

## SDL_PROP_TEXTURE_CREATE_HEIGHT_NUMBER

#define SDL_PROP_TEXTURE_CREATE_HEIGHT_NUMBER "SDL.texture.create.height"

Definition at line 702 of file SDL_render.h.

## SDL_PROP_TEXTURE_CREATE_METAL_PIXELBUFFER_POINTER

#define SDL_PROP_TEXTURE_CREATE_METAL_PIXELBUFFER_POINTER "SDL.texture.create.metal.pixelbuffer"

Definition at line 711 of file SDL_render.h.

## SDL_PROP_TEXTURE_CREATE_OPENGL_TEXTURE_NUMBER

#define SDL_PROP_TEXTURE_CREATE_OPENGL_TEXTURE_NUMBER "SDL.texture.create.opengl.texture"

Definition at line 712 of file SDL_render.h.

## SDL_PROP_TEXTURE_CREATE_OPENGL_TEXTURE_U_NUMBER

#define SDL_PROP_TEXTURE_CREATE_OPENGL_TEXTURE_U_NUMBER "SDL.texture.create.opengl.texture_u"

Definition at line 714 of file SDL_render.h.

## SDL_PROP_TEXTURE_CREATE_OPENGL_TEXTURE_UV_NUMBER

#define SDL_PROP_TEXTURE_CREATE_OPENGL_TEXTURE_UV_NUMBER "SDL.texture.create.opengl.texture_uv"

Definition at line 713 of file SDL_render.h.

## SDL_PROP_TEXTURE_CREATE_OPENGL_TEXTURE_V_NUMBER

#define SDL_PROP_TEXTURE_CREATE_OPENGL_TEXTURE_V_NUMBER "SDL.texture.create.opengl.texture_v"

Definition at line 715 of file SDL_render.h.

## SDL_PROP_TEXTURE_CREATE_OPENGLES2_TEXTURE_NUMBER

#define SDL_PROP_TEXTURE_CREATE_OPENGLES2_TEXTURE_NUMBER "SDL.texture.create.opengles2.texture"

Definition at line 716 of file SDL_render.h.

## SDL_PROP_TEXTURE_CREATE_OPENGLES2_TEXTURE_U_NUMBER

#define SDL_PROP_TEXTURE_CREATE_OPENGLES2_TEXTURE_U_NUMBER "SDL.texture.create.opengles2.texture_u"

Definition at line 718 of file SDL_render.h.

## SDL_PROP_TEXTURE_CREATE_OPENGLES2_TEXTURE_UV_NUMBER

#define SDL_PROP_TEXTURE_CREATE_OPENGLES2_TEXTURE_UV_NUMBER "SDL.texture.create.opengles2.texture_uv"

Definition at line 717 of file SDL_render.h.

## SDL_PROP_TEXTURE_CREATE_OPENGLES2_TEXTURE_V_NUMBER

#define SDL_PROP_TEXTURE_CREATE_OPENGLES2_TEXTURE_V_NUMBER "SDL.texture.create.opengles2.texture_v"

Definition at line 719 of file SDL_render.h.

## SDL_PROP_TEXTURE_CREATE_SDR_WHITE_POINT_FLOAT

#define SDL_PROP_TEXTURE_CREATE_SDR_WHITE_POINT_FLOAT "SDL.texture.create.SDR_white_point"

Definition at line 703 of file SDL_render.h.

## SDL_PROP_TEXTURE_CREATE_VULKAN_TEXTURE_NUMBER

#define SDL_PROP_TEXTURE_CREATE_VULKAN_TEXTURE_NUMBER "SDL.texture.create.vulkan.texture"

Definition at line 720 of file SDL_render.h.

## SDL_PROP_TEXTURE_CREATE_WIDTH_NUMBER

#define SDL_PROP_TEXTURE_CREATE_WIDTH_NUMBER "SDL.texture.create.width"

Definition at line 701 of file SDL_render.h.

## SDL_PROP_TEXTURE_D3D11_TEXTURE_POINTER

#define SDL_PROP_TEXTURE_D3D11_TEXTURE_POINTER "SDL.texture.d3d11.texture"

Definition at line 817 of file SDL_render.h.

## SDL_PROP_TEXTURE_D3D11_TEXTURE_U_POINTER

#define SDL_PROP_TEXTURE_D3D11_TEXTURE_U_POINTER "SDL.texture.d3d11.texture_u"

Definition at line 818 of file SDL_render.h.

## SDL_PROP_TEXTURE_D3D11_TEXTURE_V_POINTER

#define SDL_PROP_TEXTURE_D3D11_TEXTURE_V_POINTER "SDL.texture.d3d11.texture_v"

Definition at line 819 of file SDL_render.h.

## SDL_PROP_TEXTURE_D3D12_TEXTURE_POINTER

#define SDL_PROP_TEXTURE_D3D12_TEXTURE_POINTER "SDL.texture.d3d12.texture"

Definition at line 820 of file SDL_render.h.

## SDL_PROP_TEXTURE_D3D12_TEXTURE_U_POINTER

#define SDL_PROP_TEXTURE_D3D12_TEXTURE_U_POINTER "SDL.texture.d3d12.texture_u"

Definition at line 821 of file SDL_render.h.

## SDL_PROP_TEXTURE_D3D12_TEXTURE_V_POINTER

#define SDL_PROP_TEXTURE_D3D12_TEXTURE_V_POINTER "SDL.texture.d3d12.texture_v"

Definition at line 822 of file SDL_render.h.

## SDL_PROP_TEXTURE_FORMAT_NUMBER

#define SDL_PROP_TEXTURE_FORMAT_NUMBER "SDL.texture.format"

Definition at line 811 of file SDL_render.h.

## SDL_PROP_TEXTURE_HDR_HEADROOM_FLOAT

#define SDL_PROP_TEXTURE_HDR_HEADROOM_FLOAT "SDL.texture.HDR_headroom"

Definition at line 816 of file SDL_render.h.

## SDL_PROP_TEXTURE_HEIGHT_NUMBER

#define SDL_PROP_TEXTURE_HEIGHT_NUMBER "SDL.texture.height"

Definition at line 814 of file SDL_render.h.

## SDL_PROP_TEXTURE_OPENGL_TEX_H_FLOAT

#define SDL_PROP_TEXTURE_OPENGL_TEX_H_FLOAT "SDL.texture.opengl.tex_h"

Definition at line 829 of file SDL_render.h.

## SDL_PROP_TEXTURE_OPENGL_TEX_W_FLOAT

#define SDL_PROP_TEXTURE_OPENGL_TEX_W_FLOAT "SDL.texture.opengl.tex_w"

Definition at line 828 of file SDL_render.h.

## SDL_PROP_TEXTURE_OPENGL_TEXTURE_NUMBER

#define SDL_PROP_TEXTURE_OPENGL_TEXTURE_NUMBER "SDL.texture.opengl.texture"

Definition at line 823 of file SDL_render.h.

## SDL_PROP_TEXTURE_OPENGL_TEXTURE_TARGET_NUMBER

#define SDL_PROP_TEXTURE_OPENGL_TEXTURE_TARGET_NUMBER "SDL.texture.opengl.target"

Definition at line 827 of file SDL_render.h.

## SDL_PROP_TEXTURE_OPENGL_TEXTURE_U_NUMBER

#define SDL_PROP_TEXTURE_OPENGL_TEXTURE_U_NUMBER "SDL.texture.opengl.texture_u"

Definition at line 825 of file SDL_render.h.

## SDL_PROP_TEXTURE_OPENGL_TEXTURE_UV_NUMBER

#define SDL_PROP_TEXTURE_OPENGL_TEXTURE_UV_NUMBER "SDL.texture.opengl.texture_uv"

Definition at line 824 of file SDL_render.h.

## SDL_PROP_TEXTURE_OPENGL_TEXTURE_V_NUMBER

#define SDL_PROP_TEXTURE_OPENGL_TEXTURE_V_NUMBER "SDL.texture.opengl.texture_v"

Definition at line 826 of file SDL_render.h.

## SDL_PROP_TEXTURE_OPENGLES2_TEXTURE_NUMBER

#define SDL_PROP_TEXTURE_OPENGLES2_TEXTURE_NUMBER "SDL.texture.opengles2.texture"

Definition at line 830 of file SDL_render.h.

## SDL_PROP_TEXTURE_OPENGLES2_TEXTURE_TARGET_NUMBER

#define SDL_PROP_TEXTURE_OPENGLES2_TEXTURE_TARGET_NUMBER "SDL.texture.opengles2.target"

Definition at line 834 of file SDL_render.h.

## SDL_PROP_TEXTURE_OPENGLES2_TEXTURE_U_NUMBER

#define SDL_PROP_TEXTURE_OPENGLES2_TEXTURE_U_NUMBER "SDL.texture.opengles2.texture_u"

Definition at line 832 of file SDL_render.h.

## SDL_PROP_TEXTURE_OPENGLES2_TEXTURE_UV_NUMBER

#define SDL_PROP_TEXTURE_OPENGLES2_TEXTURE_UV_NUMBER "SDL.texture.opengles2.texture_uv"

Definition at line 831 of file SDL_render.h.

## SDL_PROP_TEXTURE_OPENGLES2_TEXTURE_V_NUMBER

#define SDL_PROP_TEXTURE_OPENGLES2_TEXTURE_V_NUMBER "SDL.texture.opengles2.texture_v"

Definition at line 833 of file SDL_render.h.

## SDL_PROP_TEXTURE_SDR_WHITE_POINT_FLOAT

#define SDL_PROP_TEXTURE_SDR_WHITE_POINT_FLOAT "SDL.texture.SDR_white_point"

Definition at line 815 of file SDL_render.h.

## SDL_PROP_TEXTURE_VULKAN_TEXTURE_NUMBER

#define SDL_PROP_TEXTURE_VULKAN_TEXTURE_NUMBER "SDL.texture.vulkan.texture"

Definition at line 835 of file SDL_render.h.

## SDL_PROP_TEXTURE_WIDTH_NUMBER

#define SDL_PROP_TEXTURE_WIDTH_NUMBER "SDL.texture.width"

Definition at line 813 of file SDL_render.h.

## SDL_RENDERER_VSYNC_ADAPTIVE

#define SDL_RENDERER_VSYNC_ADAPTIVE (-1)

Definition at line 2540 of file SDL_render.h.

## SDL_RENDERER_VSYNC_DISABLED

#define SDL_RENDERER_VSYNC_DISABLED 0

Definition at line 2539 of file SDL_render.h.

## SDL_SOFTWARE_RENDERER

#define SDL_SOFTWARE_RENDERER "software"

# CategoryRender

Header file for SDL 2D rendering functions.

This API supports the following features:

- single pixel points
- single pixel lines
- filled rectangles
- texture images
- 2D polygons

The primitives may be drawn in opaque, blended, or additive modes.

The texture images may be drawn in opaque, blended, or additive modes. They can have an additional color tint or alpha modulation applied to them, and may also be stretched with linear interpolation.

This API is designed to accelerate simple 2D operations. You may want more functionality such as polygons and particle effects and in that case you should use SDL's OpenGL/Direct3D support, the SDL3 GPU API, or one of the many good 3D engines.

These functions must be called from the main thread. See this bug for details: https://github.com/libsdl-org/SDL/issues/986 The name of the software renderer.

Since
  This macro is available since SDL 3.2.0.

Definition at line 74 of file SDL_render.h.

## Typedef Documentation

## SDL_Renderer

typedef struct SDL_Renderer SDL_Renderer

A structure representing rendering state

Since
  This struct is available since SDL 3.2.0.

Definition at line 119 of file SDL_render.h.

## Enumeration Type Documentation

## SDL_RendererLogicalPresentation

enum SDL_RendererLogicalPresentation

How the logical size is mapped to the output.

Since
  This enum is available since SDL 3.2.0.

Enumerator
SDL_LOGICAL_PRESENTATION_DISABLED | There is no logical size in effect
SDL_LOGICAL_PRESENTATION_STRETCH | The rendered content is stretched to the output resolution
SDL_LOGICAL_PRESENTATION_LETTERBOX | The rendered content is fit to the largest dimension and the other dimension is letterboxed with black bars
SDL_LOGICAL_PRESENTATION_OVERSCAN | The rendered content is fit to the smallest dimension and the other dimension extends beyond the output bounds
SDL_LOGICAL_PRESENTATION_INTEGER_SCALE | The rendered content is scaled up by integer multiples to fit the output resolution

Definition at line 105 of file SDL_render.h.

{
SDL_LOGICAL_PRESENTATION_DISABLED, /**< There is no logical size in effect */
SDL_LOGICAL_PRESENTATION_STRETCH, /**< The rendered content is stretched to the output resolution */
SDL_LOGICAL_PRESENTATION_LETTERBOX, /**< The rendered content is fit to the largest dimension and the other dimension is letterboxed with black bars */
SDL_LOGICAL_PRESENTATION_OVERSCAN, /**< The rendered content is fit to the smallest dimension and the other dimension extends beyond the output bounds */
SDL_LOGICAL_PRESENTATION_INTEGER_SCALE /**< The rendered content is scaled up by integer multiples to fit the output resolution */
} SDL_RendererLogicalPresentation;
SDL_RendererLogicalPresentation
SDL_RendererLogicalPresentation
Definition SDL_render.h:106
SDL_LOGICAL_PRESENTATION_LETTERBOX
@ SDL_LOGICAL_PRESENTATION_LETTERBOX
Definition SDL_render.h:109
SDL_LOGICAL_PRESENTATION_DISABLED
@ SDL_LOGICAL_PRESENTATION_DISABLED
Definition SDL_render.h:107
SDL_LOGICAL_PRESENTATION_OVERSCAN
@ SDL_LOGICAL_PRESENTATION_OVERSCAN
Definition SDL_render.h:110
SDL_LOGICAL_PRESENTATION_STRETCH
@ SDL_LOGICAL_PRESENTATION_STRETCH
Definition SDL_render.h:108
SDL_LOGICAL_PRESENTATION_INTEGER_SCALE
@ SDL_LOGICAL_PRESENTATION_INTEGER_SCALE
Definition SDL_render.h:111

## SDL_TextureAccess

enum SDL_TextureAccess

The access pattern allowed for a texture.

Since
  This enum is available since SDL 3.2.0.

Enumerator
SDL_TEXTUREACCESS_STATIC | Changes rarely, not lockable
SDL_TEXTUREACCESS_STREAMING | Changes frequently, lockable
SDL_TEXTUREACCESS_TARGET | Texture can be used as a render target

Definition at line 93 of file SDL_render.h.

{
SDL_TEXTUREACCESS_STATIC, /**< Changes rarely, not lockable */
SDL_TEXTUREACCESS_STREAMING, /**< Changes frequently, lockable */
SDL_TEXTUREACCESS_TARGET /**< Texture can be used as a render target */
} SDL_TextureAccess;
SDL_TextureAccess
SDL_TextureAccess
Definition SDL_render.h:94
SDL_TEXTUREACCESS_STATIC
@ SDL_TEXTUREACCESS_STATIC
Definition SDL_render.h:95
SDL_TEXTUREACCESS_STREAMING
@ SDL_TEXTUREACCESS_STREAMING
Definition SDL_render.h:96
SDL_TEXTUREACCESS_TARGET
@ SDL_TEXTUREACCESS_TARGET
Definition SDL_render.h:97

## Function Documentation

## SDL_AddVulkanRenderSemaphores()

bool SDL_AddVulkanRenderSemaphores | ( | SDL_Renderer * | renderer,
|  | Uint32 | wait_stage_mask,
|  | Sint64 | wait_semaphore,
|  | Sint64 | signal_semaphore
| ) |  |

extern

Add a set of synchronization semaphores for the current frame.

The Vulkan renderer will wait for `wait_semaphore` before submitting rendering commands and signal `signal_semaphore` after rendering commands are complete for this frame.

This should be called each frame that you want semaphore synchronization. The Vulkan renderer may have multiple frames in flight on the GPU, so you should have multiple semaphores that are used for synchronization. Querying SDL_PROP_RENDERER_VULKAN_SWAPCHAIN_IMAGE_COUNT_NUMBER will give you the maximum number of semaphores you'll need.

Parameters

  renderer | the rendering context.
  wait_stage_mask | the VkPipelineStageFlags for the wait.
  wait_semaphore | a VkSempahore to wait on before rendering the current frame, or 0 if not needed.
  signal_semaphore | a VkSempahore that SDL will signal when rendering for the current frame is complete, or 0 if not needed.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety It is NOT safe to call this function from two threads at once.

Since
  This function is available since SDL 3.2.0.

## SDL_ConvertEventToRenderCoordinates()

bool SDL_ConvertEventToRenderCoordinates | ( | SDL_Renderer * | renderer,
|  | SDL_Event * | event
| ) |  |

extern

Convert the coordinates in an event to render coordinates.

This takes into account several states:

- The window dimensions.
- The logical presentation settings (SDL_SetRenderLogicalPresentation)
- The scale (SDL_SetRenderScale)
- The viewport (SDL_SetRenderViewport)

Various event types are converted with this function: mouse, touch, pen, etc.

Touch coordinates are converted from normalized coordinates in the window to non-normalized rendering coordinates.

Relative mouse coordinates (xrel and yrel event fields) are also converted. Applications that do not want these fields converted should use SDL_RenderCoordinatesFromWindow() on the specific event fields instead of converting the entire event structure.

Once converted, coordinates may be outside the rendering area.

Parameters

  renderer | the rendering context.
  event | the event to modify.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_RenderCoordinatesFromWindow

## SDL_CreateRenderer()

SDL_Renderer * SDL_CreateRenderer | ( | SDL_Window * | window,
|  | const char * | name
| ) |  |

extern

Create a 2D rendering context for a window.

If you want a specific renderer, you can specify its name here. A list of available renderers can be obtained by calling SDL_GetRenderDriver() multiple times, with indices from 0 to SDL_GetNumRenderDrivers()-1. If you don't need a specific renderer, specify NULL and SDL will attempt to choose the best option for you, based on what is available on the user's system.

If `name` is a comma-separated list, SDL will try each name, in the order listed, until one succeeds or all of them fail.

By default the rendering size matches the window size in pixels, but you can call SDL_SetRenderLogicalPresentation() to change the content size and scaling options.

Parameters

  window | the window where rendering is displayed.
  name | the name of the rendering driver to initialize, or NULL to let SDL choose one.

Returns
  a valid rendering context or NULL if there was an error; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_CreateRendererWithProperties
  SDL_CreateSoftwareRenderer
  SDL_DestroyRenderer
  SDL_GetNumRenderDrivers
  SDL_GetRenderDriver
  SDL_GetRendererName

## SDL_CreateRendererWithProperties()

SDL_Renderer * SDL_CreateRendererWithProperties | ( | SDL_PropertiesID | props | ) |

extern

Create a 2D rendering context for a window, with the specified properties.

These are the supported properties:

- `SDL_PROP_RENDERER_CREATE_NAME_STRING`: the name of the rendering driver to use, if a specific one is desired
- `SDL_PROP_RENDERER_CREATE_WINDOW_POINTER`: the window where rendering is displayed, required if this isn't a software renderer using a surface
- `SDL_PROP_RENDERER_CREATE_SURFACE_POINTER`: the surface where rendering is displayed, if you want a software renderer without a window
- `SDL_PROP_RENDERER_CREATE_OUTPUT_COLORSPACE_NUMBER`: an SDL_Colorspace value describing the colorspace for output to the display, defaults to SDL_COLORSPACE_SRGB. The direct3d11, direct3d12, and metal renderers support SDL_COLORSPACE_SRGB_LINEAR, which is a linear color space and supports HDR output. If you select SDL_COLORSPACE_SRGB_LINEAR, drawing still uses the sRGB colorspace, but values can go beyond 1.0 and float (linear) format textures can be used for HDR content.
- `SDL_PROP_RENDERER_CREATE_PRESENT_VSYNC_NUMBER`: non-zero if you want present synchronized with the refresh rate. This property can take any value that is supported by SDL_SetRenderVSync() for the renderer.

With the vulkan renderer:

- `SDL_PROP_RENDERER_CREATE_VULKAN_INSTANCE_POINTER`: the VkInstance to use with the renderer, optional.
- `SDL_PROP_RENDERER_CREATE_VULKAN_SURFACE_NUMBER`: the VkSurfaceKHR to use with the renderer, optional.
- `SDL_PROP_RENDERER_CREATE_VULKAN_PHYSICAL_DEVICE_POINTER`: the VkPhysicalDevice to use with the renderer, optional.
- `SDL_PROP_RENDERER_CREATE_VULKAN_DEVICE_POINTER`: the VkDevice to use with the renderer, optional.
- `SDL_PROP_RENDERER_CREATE_VULKAN_GRAPHICS_QUEUE_FAMILY_INDEX_NUMBER`: the queue family index used for rendering.
- `SDL_PROP_RENDERER_CREATE_VULKAN_PRESENT_QUEUE_FAMILY_INDEX_NUMBER`: the queue family index used for presentation.

Parameters

  props | the properties to use.

Returns
  a valid rendering context or NULL if there was an error; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_CreateProperties
  SDL_CreateRenderer
  SDL_CreateSoftwareRenderer
  SDL_DestroyRenderer
  SDL_GetRendererName

## SDL_CreateSoftwareRenderer()

SDL_Renderer * SDL_CreateSoftwareRenderer | ( | SDL_Surface * | surface | ) |

extern

Create a 2D software rendering context for a surface.

Two other API which can be used to create SDL_Renderer: SDL_CreateRenderer() and SDL_CreateWindowAndRenderer(). These can also create a software renderer, but they are intended to be used with an SDL_Window as the final destination and not an SDL_Surface.

Parameters

  surface | the SDL_Surface structure representing the surface where rendering is done.

Returns
  a valid rendering context or NULL if there was an error; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_DestroyRenderer

## SDL_CreateTexture()

SDL_Texture * SDL_CreateTexture | ( | SDL_Renderer * | renderer,
|  | SDL_PixelFormat | format,
|  | SDL_TextureAccess | access,
|  | int | w,
|  | int | h
| ) |  |

extern

Create a texture for a rendering context.

The contents of a texture when first created are not defined.

Parameters

  renderer | the rendering context.
  format | one of the enumerated values in SDL_PixelFormat.
  access | one of the enumerated values in SDL_TextureAccess.
  w | the width of the texture in pixels.
  h | the height of the texture in pixels.

Returns
  the created texture or NULL on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_CreateTextureFromSurface
  SDL_CreateTextureWithProperties
  SDL_DestroyTexture
  SDL_GetTextureSize
  SDL_UpdateTexture

## SDL_CreateTextureFromSurface()

SDL_Texture * SDL_CreateTextureFromSurface | ( | SDL_Renderer * | renderer,
|  | SDL_Surface * | surface
| ) |  |

extern

Create a texture from an existing surface.

The surface is not modified or freed by this function.

The SDL_TextureAccess hint for the created texture is `SDL_TEXTUREACCESS_STATIC`.

The pixel format of the created texture may be different from the pixel format of the surface, and can be queried using the SDL_PROP_TEXTURE_FORMAT_NUMBER property.

Parameters

  renderer | the rendering context.
  surface | the SDL_Surface structure containing pixel data used to fill the texture.

Returns
  the created texture or NULL on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_CreateTexture
  SDL_CreateTextureWithProperties
  SDL_DestroyTexture

## SDL_CreateTextureWithProperties()

SDL_Texture * SDL_CreateTextureWithProperties | ( | SDL_Renderer * | renderer,
|  | SDL_PropertiesID | props
| ) |  |

extern

Create a texture for a rendering context with the specified properties.

These are the supported properties:

- `SDL_PROP_TEXTURE_CREATE_COLORSPACE_NUMBER`: an SDL_Colorspace value describing the texture colorspace, defaults to SDL_COLORSPACE_SRGB_LINEAR for floating point textures, SDL_COLORSPACE_HDR10 for 10-bit textures, SDL_COLORSPACE_SRGB for other RGB textures and SDL_COLORSPACE_JPEG for YUV textures.
- `SDL_PROP_TEXTURE_CREATE_FORMAT_NUMBER`: one of the enumerated values in SDL_PixelFormat, defaults to the best RGBA format for the renderer
- `SDL_PROP_TEXTURE_CREATE_ACCESS_NUMBER`: one of the enumerated values in SDL_TextureAccess, defaults to SDL_TEXTUREACCESS_STATIC
- `SDL_PROP_TEXTURE_CREATE_WIDTH_NUMBER`: the width of the texture in pixels, required
- `SDL_PROP_TEXTURE_CREATE_HEIGHT_NUMBER`: the height of the texture in pixels, required
- `SDL_PROP_TEXTURE_CREATE_SDR_WHITE_POINT_FLOAT`: for HDR10 and floating point textures, this defines the value of 100% diffuse white, with higher values being displayed in the High Dynamic Range headroom. This defaults to 100 for HDR10 textures and 1.0 for floating point textures.
- `SDL_PROP_TEXTURE_CREATE_HDR_HEADROOM_FLOAT`: for HDR10 and floating point textures, this defines the maximum dynamic range used by the content, in terms of the SDR white point. This would be equivalent to maxCLL / SDL_PROP_TEXTURE_CREATE_SDR_WHITE_POINT_FLOAT for HDR10 content. If this is defined, any values outside the range supported by the display will be scaled into the available HDR headroom, otherwise they are clipped.

With the direct3d11 renderer:

- `SDL_PROP_TEXTURE_CREATE_D3D11_TEXTURE_POINTER`: the ID3D11Texture2D associated with the texture, if you want to wrap an existing texture.
- `SDL_PROP_TEXTURE_CREATE_D3D11_TEXTURE_U_POINTER`: the ID3D11Texture2D associated with the U plane of a YUV texture, if you want to wrap an existing texture.
- `SDL_PROP_TEXTURE_CREATE_D3D11_TEXTURE_V_POINTER`: the ID3D11Texture2D associated with the V plane of a YUV texture, if you want to wrap an existing texture.

With the direct3d12 renderer:

- `SDL_PROP_TEXTURE_CREATE_D3D12_TEXTURE_POINTER`: the ID3D12Resource associated with the texture, if you want to wrap an existing texture.
- `SDL_PROP_TEXTURE_CREATE_D3D12_TEXTURE_U_POINTER`: the ID3D12Resource associated with the U plane of a YUV texture, if you want to wrap an existing texture.
- `SDL_PROP_TEXTURE_CREATE_D3D12_TEXTURE_V_POINTER`: the ID3D12Resource associated with the V plane of a YUV texture, if you want to wrap an existing texture.

With the metal renderer:

- `SDL_PROP_TEXTURE_CREATE_METAL_PIXELBUFFER_POINTER`: the CVPixelBufferRef associated with the texture, if you want to create a texture from an existing pixel buffer.

With the opengl renderer:

- `SDL_PROP_TEXTURE_CREATE_OPENGL_TEXTURE_NUMBER`: the GLuint texture associated with the texture, if you want to wrap an existing texture.
- `SDL_PROP_TEXTURE_CREATE_OPENGL_TEXTURE_UV_NUMBER`: the GLuint texture associated with the UV plane of an NV12 texture, if you want to wrap an existing texture.
- `SDL_PROP_TEXTURE_CREATE_OPENGL_TEXTURE_U_NUMBER`: the GLuint texture associated with the U plane of a YUV texture, if you want to wrap an existing texture.
- `SDL_PROP_TEXTURE_CREATE_OPENGL_TEXTURE_V_NUMBER`: the GLuint texture associated with the V plane of a YUV texture, if you want to wrap an existing texture.

With the opengles2 renderer:

- `SDL_PROP_TEXTURE_CREATE_OPENGLES2_TEXTURE_NUMBER`: the GLuint texture associated with the texture, if you want to wrap an existing texture.
- `SDL_PROP_TEXTURE_CREATE_OPENGLES2_TEXTURE_NUMBER`: the GLuint texture associated with the texture, if you want to wrap an existing texture.
- `SDL_PROP_TEXTURE_CREATE_OPENGLES2_TEXTURE_UV_NUMBER`: the GLuint texture associated with the UV plane of an NV12 texture, if you want to wrap an existing texture.
- `SDL_PROP_TEXTURE_CREATE_OPENGLES2_TEXTURE_U_NUMBER`: the GLuint texture associated with the U plane of a YUV texture, if you want to wrap an existing texture.
- `SDL_PROP_TEXTURE_CREATE_OPENGLES2_TEXTURE_V_NUMBER`: the GLuint texture associated with the V plane of a YUV texture, if you want to wrap an existing texture.

With the vulkan renderer:

- `SDL_PROP_TEXTURE_CREATE_VULKAN_TEXTURE_NUMBER`: the VkImage with layout VK_IMAGE_LAYOUT_SHADER_READ_ONLY_OPTIMAL associated with the texture, if you want to wrap an existing texture.

Parameters

  renderer | the rendering context.
  props | the properties to use.

Returns
  the created texture or NULL on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_CreateProperties
  SDL_CreateTexture
  SDL_CreateTextureFromSurface
  SDL_DestroyTexture
  SDL_GetTextureSize
  SDL_UpdateTexture

## SDL_CreateWindowAndRenderer()

bool SDL_CreateWindowAndRenderer | ( | const char * | title,
|  | int | width,
|  | int | height,
|  | SDL_WindowFlags | window_flags,
|  | SDL_Window ** | window,
|  | SDL_Renderer ** | renderer
| ) |  |

extern

Create a window and default renderer.

Parameters

  title | the title of the window, in UTF-8 encoding.
  width | the width of the window.
  height | the height of the window.
  window_flags | the flags used to create the window (see SDL_CreateWindow()).
  window | a pointer filled with the window, or NULL on error.
  renderer | a pointer filled with the renderer, or NULL on error.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_CreateRenderer
  SDL_CreateWindow

Referenced by SDL_AppInit().

## SDL_DestroyRenderer()

void SDL_DestroyRenderer | ( | SDL_Renderer * | renderer | ) |

extern

Destroy the rendering context for a window and free all associated textures.

This should be called before destroying the associated window.

Parameters

  renderer | the rendering context.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_CreateRenderer

## SDL_DestroyTexture()

void SDL_DestroyTexture | ( | SDL_Texture * | texture | ) |

extern

Destroy the specified texture.

Passing NULL or an otherwise invalid texture will set the SDL error message to "Invalid texture".

Parameters

  texture | the texture to destroy.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_CreateTexture
  SDL_CreateTextureFromSurface

## SDL_FlushRenderer()

bool SDL_FlushRenderer | ( | SDL_Renderer * | renderer | ) |

extern

Force the rendering context to flush any pending commands and state.

You do not need to (and in fact, shouldn't) call this function unless you are planning to call into OpenGL/Direct3D/Metal/whatever directly, in addition to using an SDL_Renderer.

This is for a very-specific case: if you are using SDL's render API, and you plan to make OpenGL/D3D/whatever calls in addition to SDL render API calls. If this applies, you should call this function between calls to SDL's render API and the low-level API you're using in cooperation.

In all other cases, you can ignore this function.

This call makes SDL flush any pending rendering work it was queueing up to do later in a single batch, and marks any internal cached state as invalid, so it'll prepare all its state again later, from scratch.

This means you do not need to save state in your rendering code to protect the SDL renderer. However, there lots of arbitrary pieces of Direct3D and OpenGL state that can confuse things; you should use your best judgment and be prepared to make changes if specific state needs to be protected.

Parameters

  renderer | the rendering context.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

## SDL_GetCurrentRenderOutputSize()

bool SDL_GetCurrentRenderOutputSize | ( | SDL_Renderer * | renderer,
|  | int * | w,
|  | int * | h
| ) |  |

extern

Get the current output size in pixels of a rendering context.

If a rendering target is active, this will return the size of the rendering target in pixels, otherwise return the value of SDL_GetRenderOutputSize().

Rendering target or not, the output will be adjusted by the current logical presentation state, dictated by SDL_SetRenderLogicalPresentation().

Parameters

  renderer | the rendering context.
  w | a pointer filled in with the current width.
  h | a pointer filled in with the current height.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetRenderOutputSize

## SDL_GetNumRenderDrivers()

int SDL_GetNumRenderDrivers | ( | void |  | ) |

extern

Get the number of 2D rendering drivers available for the current display.

A render driver is a set of code that handles rendering and texture management on a particular display. Normally there is only one, but some drivers may have several available with different capabilities.

There may be none if SDL was compiled without render support.

Returns
  the number of built in render drivers.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_CreateRenderer
  SDL_GetRenderDriver

## SDL_GetRenderClipRect()

bool SDL_GetRenderClipRect | ( | SDL_Renderer * | renderer,
|  | SDL_Rect * | rect
| ) |  |

extern

Get the clip rectangle for the current target.

Each render target has its own clip rectangle. This function gets the cliprect for the current render target.

Parameters

  renderer | the rendering context.
  rect | an SDL_Rect structure filled in with the current clipping area or an empty rectangle if clipping is disabled.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_RenderClipEnabled
  SDL_SetRenderClipRect

## SDL_GetRenderColorScale()

bool SDL_GetRenderColorScale | ( | SDL_Renderer * | renderer,
|  | float * | scale
| ) |  |

extern

Get the color scale used for render operations.

Parameters

  renderer | the rendering context.
  scale | a pointer filled in with the current color scale value.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_SetRenderColorScale

## SDL_GetRenderDrawBlendMode()

bool SDL_GetRenderDrawBlendMode | ( | SDL_Renderer * | renderer,
|  | SDL_BlendMode * | blendMode
| ) |  |

extern

Get the blend mode used for drawing operations.

Parameters

  renderer | the rendering context.
  blendMode | a pointer filled in with the current SDL_BlendMode.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_SetRenderDrawBlendMode

## SDL_GetRenderDrawColor()

bool SDL_GetRenderDrawColor | ( | SDL_Renderer * | renderer,
|  | Uint8 * | r,
|  | Uint8 * | g,
|  | Uint8 * | b,
|  | Uint8 * | a
| ) |  |

extern

Get the color used for drawing operations (Rect, Line and Clear).

Parameters

  renderer | the rendering context.
  r | a pointer filled in with the red value used to draw on the rendering target.
  g | a pointer filled in with the green value used to draw on the rendering target.
  b | a pointer filled in with the blue value used to draw on the rendering target.
  a | a pointer filled in with the alpha value used to draw on the rendering target; usually `SDL_ALPHA_OPAQUE` (255).

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetRenderDrawColorFloat
  SDL_SetRenderDrawColor

## SDL_GetRenderDrawColorFloat()

bool SDL_GetRenderDrawColorFloat | ( | SDL_Renderer * | renderer,
|  | float * | r,
|  | float * | g,
|  | float * | b,
|  | float * | a
| ) |  |

extern

Get the color used for drawing operations (Rect, Line and Clear).

Parameters

  renderer | the rendering context.
  r | a pointer filled in with the red value used to draw on the rendering target.
  g | a pointer filled in with the green value used to draw on the rendering target.
  b | a pointer filled in with the blue value used to draw on the rendering target.
  a | a pointer filled in with the alpha value used to draw on the rendering target.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_SetRenderDrawColorFloat
  SDL_GetRenderDrawColor

## SDL_GetRenderDriver()

const char * SDL_GetRenderDriver | ( | int | index | ) |

extern

Use this function to get the name of a built in 2D rendering driver.

The list of rendering drivers is given in the order that they are normally initialized by default; the drivers that seem more reasonable to choose first (as far as the SDL developers believe) are earlier in the list.

The names of drivers are all simple, low-ASCII identifiers, like "opengl", "direct3d12" or "metal". These never have Unicode characters, and are not meant to be proper names.

Parameters

  index | the index of the rendering driver; the value ranges from 0 to SDL_GetNumRenderDrivers() - 1.

Returns
  the name of the rendering driver at the requested index, or NULL if an invalid index was specified.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetNumRenderDrivers

## SDL_GetRenderer()

SDL_Renderer * SDL_GetRenderer | ( | SDL_Window * | window | ) |

extern

Get the renderer associated with a window.

Parameters

  window | the window to query.

Returns
  the rendering context on success or NULL on failure; call SDL_GetError() for more information.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

## SDL_GetRendererFromTexture()

SDL_Renderer * SDL_GetRendererFromTexture | ( | SDL_Texture * | texture | ) |

extern

Get the renderer that created an SDL_Texture.

Parameters

  texture | the texture to query.

Returns
  a pointer to the SDL_Renderer that created the texture, or NULL on failure; call SDL_GetError() for more information.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

## SDL_GetRendererName()

const char * SDL_GetRendererName | ( | SDL_Renderer * | renderer | ) |

extern

Get the name of a renderer.

Parameters

  renderer | the rendering context.

Returns
  the name of the selected renderer, or NULL on failure; call SDL_GetError() for more information.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_CreateRenderer
  SDL_CreateRendererWithProperties

## SDL_GetRendererProperties()

SDL_PropertiesID SDL_GetRendererProperties | ( | SDL_Renderer * | renderer | ) |

extern

Get the properties associated with a renderer.

The following read-only properties are provided by SDL:

- `SDL_PROP_RENDERER_NAME_STRING`: the name of the rendering driver
- `SDL_PROP_RENDERER_WINDOW_POINTER`: the window where rendering is displayed, if any
- `SDL_PROP_RENDERER_SURFACE_POINTER`: the surface where rendering is displayed, if this is a software renderer without a window
- `SDL_PROP_RENDERER_VSYNC_NUMBER`: the current vsync setting
- `SDL_PROP_RENDERER_MAX_TEXTURE_SIZE_NUMBER`: the maximum texture width and height
- `SDL_PROP_RENDERER_TEXTURE_FORMATS_POINTER`: a (const SDL_PixelFormat *) array of pixel formats, terminated with SDL_PIXELFORMAT_UNKNOWN, representing the available texture formats for this renderer.
- `SDL_PROP_RENDERER_OUTPUT_COLORSPACE_NUMBER`: an SDL_Colorspace value describing the colorspace for output to the display, defaults to SDL_COLORSPACE_SRGB.
- `SDL_PROP_RENDERER_HDR_ENABLED_BOOLEAN`: true if the output colorspace is SDL_COLORSPACE_SRGB_LINEAR and the renderer is showing on a display with HDR enabled. This property can change dynamically when SDL_EVENT_WINDOW_HDR_STATE_CHANGED is sent.
- `SDL_PROP_RENDERER_SDR_WHITE_POINT_FLOAT`: the value of SDR white in the SDL_COLORSPACE_SRGB_LINEAR colorspace. When HDR is enabled, this value is automatically multiplied into the color scale. This property can change dynamically when SDL_EVENT_WINDOW_HDR_STATE_CHANGED is sent.
- `SDL_PROP_RENDERER_HDR_HEADROOM_FLOAT`: the additional high dynamic range that can be displayed, in terms of the SDR white point. When HDR is not enabled, this will be 1.0. This property can change dynamically when SDL_EVENT_WINDOW_HDR_STATE_CHANGED is sent.

With the direct3d renderer:

- `SDL_PROP_RENDERER_D3D9_DEVICE_POINTER`: the IDirect3DDevice9 associated with the renderer

With the direct3d11 renderer:

- `SDL_PROP_RENDERER_D3D11_DEVICE_POINTER`: the ID3D11Device associated with the renderer
- `SDL_PROP_RENDERER_D3D11_SWAPCHAIN_POINTER`: the IDXGISwapChain1 associated with the renderer. This may change when the window is resized.

With the direct3d12 renderer:

- `SDL_PROP_RENDERER_D3D12_DEVICE_POINTER`: the ID3D12Device associated with the renderer
- `SDL_PROP_RENDERER_D3D12_SWAPCHAIN_POINTER`: the IDXGISwapChain4 associated with the renderer.
- `SDL_PROP_RENDERER_D3D12_COMMAND_QUEUE_POINTER`: the ID3D12CommandQueue associated with the renderer

With the vulkan renderer:

- `SDL_PROP_RENDERER_VULKAN_INSTANCE_POINTER`: the VkInstance associated with the renderer
- `SDL_PROP_RENDERER_VULKAN_SURFACE_NUMBER`: the VkSurfaceKHR associated with the renderer
- `SDL_PROP_RENDERER_VULKAN_PHYSICAL_DEVICE_POINTER`: the VkPhysicalDevice associated with the renderer
- `SDL_PROP_RENDERER_VULKAN_DEVICE_POINTER`: the VkDevice associated with the renderer
- `SDL_PROP_RENDERER_VULKAN_GRAPHICS_QUEUE_FAMILY_INDEX_NUMBER`: the queue family index used for rendering
- `SDL_PROP_RENDERER_VULKAN_PRESENT_QUEUE_FAMILY_INDEX_NUMBER`: the queue family index used for presentation
- `SDL_PROP_RENDERER_VULKAN_SWAPCHAIN_IMAGE_COUNT_NUMBER`: the number of swapchain images, or potential frames in flight, used by the Vulkan renderer

With the gpu renderer:

- `SDL_PROP_RENDERER_GPU_DEVICE_POINTER`: the SDL_GPUDevice associated with the renderer

Parameters

  renderer | the rendering context.

Returns
  a valid property ID on success or 0 on failure; call SDL_GetError() for more information.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

## SDL_GetRenderLogicalPresentation()

bool SDL_GetRenderLogicalPresentation | ( | SDL_Renderer * | renderer,
|  | int * | w,
|  | int * | h,
|  | SDL_RendererLogicalPresentation * | mode
| ) |  |

extern

Get device independent resolution and presentation mode for rendering.

This function gets the width and height of the logical rendering output, or the output size in pixels if a logical resolution is not enabled.

Each render target has its own logical presentation state. This function gets the state for the current render target.

Parameters

  renderer | the rendering context.
  w | an int to be filled with the width.
  h | an int to be filled with the height.
  mode | the presentation mode used.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_SetRenderLogicalPresentation

## SDL_GetRenderLogicalPresentationRect()

bool SDL_GetRenderLogicalPresentationRect | ( | SDL_Renderer * | renderer,
|  | SDL_FRect * | rect
| ) |  |

extern

Get the final presentation rectangle for rendering.

This function returns the calculated rectangle used for logical presentation, based on the presentation mode and output size. If logical presentation is disabled, it will fill the rectangle with the output size, in pixels.

Each render target has its own logical presentation state. This function gets the rectangle for the current render target.

Parameters

  renderer | the rendering context.
  rect | a pointer filled in with the final presentation rectangle, may be NULL.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_SetRenderLogicalPresentation

## SDL_GetRenderMetalCommandEncoder()

void * SDL_GetRenderMetalCommandEncoder | ( | SDL_Renderer * | renderer | ) |

extern

Get the Metal command encoder for the current frame.

This function returns `void *`, so SDL doesn't have to include Metal's headers, but it can be safely cast to an `id<MTLRenderCommandEncoder>`.

This will return NULL if Metal refuses to give SDL a drawable to render to, which might happen if the window is hidden/minimized/offscreen. This doesn't apply to command encoders for render targets, just the window's backbuffer. Check your return values!

Parameters

  renderer | the renderer to query.

Returns
  an `id<MTLRenderCommandEncoder>` on success, or NULL if the renderer isn't a Metal renderer or there was an error.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetRenderMetalLayer

## SDL_GetRenderMetalLayer()

void * SDL_GetRenderMetalLayer | ( | SDL_Renderer * | renderer | ) |

extern

Get the CAMetalLayer associated with the given Metal renderer.

This function returns `void *`, so SDL doesn't have to include Metal's headers, but it can be safely cast to a `CAMetalLayer *`.

Parameters

  renderer | the renderer to query.

Returns
  a `CAMetalLayer *` on success, or NULL if the renderer isn't a Metal renderer.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetRenderMetalCommandEncoder

## SDL_GetRenderOutputSize()

bool SDL_GetRenderOutputSize | ( | SDL_Renderer * | renderer,
|  | int * | w,
|  | int * | h
| ) |  |

extern

Get the output size in pixels of a rendering context.

This returns the true output size in pixels, ignoring any render targets or logical size and presentation.

For the output size of the current rendering target, with logical size adjustments, use SDL_GetCurrentRenderOutputSize() instead.

Parameters

  renderer | the rendering context.
  w | a pointer filled in with the width in pixels.
  h | a pointer filled in with the height in pixels.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetCurrentRenderOutputSize

Referenced by SDL_AppIterate().

## SDL_GetRenderSafeArea()

bool SDL_GetRenderSafeArea | ( | SDL_Renderer * | renderer,
|  | SDL_Rect * | rect
| ) |  |

extern

Get the safe area for rendering within the current viewport.

Some devices have portions of the screen which are partially obscured or not interactive, possibly due to on-screen controls, curved edges, camera notches, TV overscan, etc. This function provides the area of the current viewport which is safe to have interactible content. You should continue rendering into the rest of the render target, but it should not contain visually important or interactible content.

Parameters

  renderer | the rendering context.
  rect | a pointer filled in with the area that is safe for interactive content.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

## SDL_GetRenderScale()

bool SDL_GetRenderScale | ( | SDL_Renderer * | renderer,
|  | float * | scaleX,
|  | float * | scaleY
| ) |  |

extern

Get the drawing scale for the current target.

Each render target has its own scale. This function gets the scale for the current render target.

Parameters

  renderer | the rendering context.
  scaleX | a pointer filled in with the horizontal scaling factor.
  scaleY | a pointer filled in with the vertical scaling factor.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_SetRenderScale

## SDL_GetRenderTarget()

SDL_Texture * SDL_GetRenderTarget | ( | SDL_Renderer * | renderer | ) |

extern

Get the current render target.

The default render target is the window for which the renderer was created, and is reported a NULL here.

Parameters

  renderer | the rendering context.

Returns
  the current render target or NULL for the default render target.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_SetRenderTarget

## SDL_GetRenderViewport()

bool SDL_GetRenderViewport | ( | SDL_Renderer * | renderer,
|  | SDL_Rect * | rect
| ) |  |

extern

Get the drawing area for the current target.

Each render target has its own viewport. This function gets the viewport for the current render target.

Parameters

  renderer | the rendering context.
  rect | an SDL_Rect structure filled in with the current drawing area.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_RenderViewportSet
  SDL_SetRenderViewport

## SDL_GetRenderVSync()

bool SDL_GetRenderVSync | ( | SDL_Renderer * | renderer,
|  | int * | vsync
| ) |  |

extern

Get VSync of the given renderer.

Parameters

  renderer | the renderer to toggle.
  vsync | an int filled with the current vertical refresh sync interval. See SDL_SetRenderVSync() for the meaning of the value.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_SetRenderVSync

## SDL_GetRenderWindow()

SDL_Window * SDL_GetRenderWindow | ( | SDL_Renderer * | renderer | ) |

extern

Get the window associated with a renderer.

Parameters

  renderer | the renderer to query.

Returns
  the window on success or NULL on failure; call SDL_GetError() for more information.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

## SDL_GetTextureAlphaMod()

bool SDL_GetTextureAlphaMod | ( | SDL_Texture * | texture,
|  | Uint8 * | alpha
| ) |  |

extern

Get the additional alpha value multiplied into render copy operations.

Parameters

  texture | the texture to query.
  alpha | a pointer filled in with the current alpha value.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetTextureAlphaModFloat
  SDL_GetTextureColorMod
  SDL_SetTextureAlphaMod

## SDL_GetTextureAlphaModFloat()

bool SDL_GetTextureAlphaModFloat | ( | SDL_Texture * | texture,
|  | float * | alpha
| ) |  |

extern

Get the additional alpha value multiplied into render copy operations.

Parameters

  texture | the texture to query.
  alpha | a pointer filled in with the current alpha value.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetTextureAlphaMod
  SDL_GetTextureColorModFloat
  SDL_SetTextureAlphaModFloat

## SDL_GetTextureBlendMode()

bool SDL_GetTextureBlendMode | ( | SDL_Texture * | texture,
|  | SDL_BlendMode * | blendMode
| ) |  |

extern

Get the blend mode used for texture copy operations.

Parameters

  texture | the texture to query.
  blendMode | a pointer filled in with the current SDL_BlendMode.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_SetTextureBlendMode

## SDL_GetTextureColorMod()

bool SDL_GetTextureColorMod | ( | SDL_Texture * | texture,
|  | Uint8 * | r,
|  | Uint8 * | g,
|  | Uint8 * | b
| ) |  |

extern

Get the additional color value multiplied into render copy operations.

Parameters

  texture | the texture to query.
  r | a pointer filled in with the current red color value.
  g | a pointer filled in with the current green color value.
  b | a pointer filled in with the current blue color value.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetTextureAlphaMod
  SDL_GetTextureColorModFloat
  SDL_SetTextureColorMod

## SDL_GetTextureColorModFloat()

bool SDL_GetTextureColorModFloat | ( | SDL_Texture * | texture,
|  | float * | r,
|  | float * | g,
|  | float * | b
| ) |  |

extern

Get the additional color value multiplied into render copy operations.

Parameters

  texture | the texture to query.
  r | a pointer filled in with the current red color value.
  g | a pointer filled in with the current green color value.
  b | a pointer filled in with the current blue color value.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetTextureAlphaModFloat
  SDL_GetTextureColorMod
  SDL_SetTextureColorModFloat

## SDL_GetTextureProperties()

SDL_PropertiesID SDL_GetTextureProperties | ( | SDL_Texture * | texture | ) |

extern

Get the properties associated with a texture.

The following read-only properties are provided by SDL:

- `SDL_PROP_TEXTURE_COLORSPACE_NUMBER`: an SDL_Colorspace value describing the texture colorspace.
- `SDL_PROP_TEXTURE_FORMAT_NUMBER`: one of the enumerated values in SDL_PixelFormat.
- `SDL_PROP_TEXTURE_ACCESS_NUMBER`: one of the enumerated values in SDL_TextureAccess.
- `SDL_PROP_TEXTURE_WIDTH_NUMBER`: the width of the texture in pixels.
- `SDL_PROP_TEXTURE_HEIGHT_NUMBER`: the height of the texture in pixels.
- `SDL_PROP_TEXTURE_SDR_WHITE_POINT_FLOAT`: for HDR10 and floating point textures, this defines the value of 100% diffuse white, with higher values being displayed in the High Dynamic Range headroom. This defaults to 100 for HDR10 textures and 1.0 for other textures.
- `SDL_PROP_TEXTURE_HDR_HEADROOM_FLOAT`: for HDR10 and floating point textures, this defines the maximum dynamic range used by the content, in terms of the SDR white point. If this is defined, any values outside the range supported by the display will be scaled into the available HDR headroom, otherwise they are clipped. This defaults to 1.0 for SDR textures, 4.0 for HDR10 textures, and no default for floating point textures.

With the direct3d11 renderer:

- `SDL_PROP_TEXTURE_D3D11_TEXTURE_POINTER`: the ID3D11Texture2D associated with the texture
- `SDL_PROP_TEXTURE_D3D11_TEXTURE_U_POINTER`: the ID3D11Texture2D associated with the U plane of a YUV texture
- `SDL_PROP_TEXTURE_D3D11_TEXTURE_V_POINTER`: the ID3D11Texture2D associated with the V plane of a YUV texture

With the direct3d12 renderer:

- `SDL_PROP_TEXTURE_D3D12_TEXTURE_POINTER`: the ID3D12Resource associated with the texture
- `SDL_PROP_TEXTURE_D3D12_TEXTURE_U_POINTER`: the ID3D12Resource associated with the U plane of a YUV texture
- `SDL_PROP_TEXTURE_D3D12_TEXTURE_V_POINTER`: the ID3D12Resource associated with the V plane of a YUV texture

With the vulkan renderer:

- `SDL_PROP_TEXTURE_VULKAN_TEXTURE_NUMBER`: the VkImage associated with the texture

With the opengl renderer:

- `SDL_PROP_TEXTURE_OPENGL_TEXTURE_NUMBER`: the GLuint texture associated with the texture
- `SDL_PROP_TEXTURE_OPENGL_TEXTURE_UV_NUMBER`: the GLuint texture associated with the UV plane of an NV12 texture
- `SDL_PROP_TEXTURE_OPENGL_TEXTURE_U_NUMBER`: the GLuint texture associated with the U plane of a YUV texture
- `SDL_PROP_TEXTURE_OPENGL_TEXTURE_V_NUMBER`: the GLuint texture associated with the V plane of a YUV texture
- `SDL_PROP_TEXTURE_OPENGL_TEXTURE_TARGET_NUMBER`: the GLenum for the texture target (`GL_TEXTURE_2D`, `GL_TEXTURE_RECTANGLE_ARB`, etc)
- `SDL_PROP_TEXTURE_OPENGL_TEX_W_FLOAT`: the texture coordinate width of the texture (0.0 - 1.0)
- `SDL_PROP_TEXTURE_OPENGL_TEX_H_FLOAT`: the texture coordinate height of the texture (0.0 - 1.0)

With the opengles2 renderer:

- `SDL_PROP_TEXTURE_OPENGLES2_TEXTURE_NUMBER`: the GLuint texture associated with the texture
- `SDL_PROP_TEXTURE_OPENGLES2_TEXTURE_UV_NUMBER`: the GLuint texture associated with the UV plane of an NV12 texture
- `SDL_PROP_TEXTURE_OPENGLES2_TEXTURE_U_NUMBER`: the GLuint texture associated with the U plane of a YUV texture
- `SDL_PROP_TEXTURE_OPENGLES2_TEXTURE_V_NUMBER`: the GLuint texture associated with the V plane of a YUV texture
- `SDL_PROP_TEXTURE_OPENGLES2_TEXTURE_TARGET_NUMBER`: the GLenum for the texture target (`GL_TEXTURE_2D`, `GL_TEXTURE_EXTERNAL_OES`, etc)

Parameters

  texture | the texture to query.

Returns
  a valid property ID on success or 0 on failure; call SDL_GetError() for more information.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

## SDL_GetTextureScaleMode()

bool SDL_GetTextureScaleMode | ( | SDL_Texture * | texture,
|  | SDL_ScaleMode * | scaleMode
| ) |  |

extern

Get the scale mode used for texture scale operations.

Parameters

  texture | the texture to query.
  scaleMode | a pointer filled in with the current scale mode.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_SetTextureScaleMode

## SDL_GetTextureSize()

bool SDL_GetTextureSize | ( | SDL_Texture * | texture,
|  | float * | w,
|  | float * | h
| ) |  |

extern

Get the size of a texture, as floating point values.

Parameters

  texture | the texture to query.
  w | a pointer filled in with the width of the texture in pixels. This argument can be NULL if you don't need this information.
  h | a pointer filled in with the height of the texture in pixels. This argument can be NULL if you don't need this information.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

## SDL_LockTexture()

bool SDL_LockTexture | ( | SDL_Texture * | texture,
|  | const SDL_Rect * | rect,
|  | void ** | pixels,
|  | int * | pitch
| ) |  |

extern

Lock a portion of the texture for write-only pixel access.

As an optimization, the pixels made available for editing don't necessarily contain the old texture data. This is a write-only operation, and if you need to keep a copy of the texture data you should do that at the application level.

You must use SDL_UnlockTexture() to unlock the pixels and apply any changes.

Parameters

  texture | the texture to lock for access, which was created with `SDL_TEXTUREACCESS_STREAMING`.
  rect | an SDL_Rect structure representing the area to lock for access; NULL to lock the entire texture.
  pixels | this is filled in with a pointer to the locked pixels, appropriately offset by the locked area.
  pitch | this is filled in with the pitch of the locked pixels; the pitch is the length of one row in bytes.

Returns
  true on success or false if the texture is not valid or was not created with `SDL_TEXTUREACCESS_STREAMING`; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_LockTextureToSurface
  SDL_UnlockTexture

## SDL_LockTextureToSurface()

bool SDL_LockTextureToSurface | ( | SDL_Texture * | texture,
|  | const SDL_Rect * | rect,
|  | SDL_Surface ** | surface
| ) |  |

extern

Lock a portion of the texture for write-only pixel access, and expose it as a SDL surface.

Besides providing an SDL_Surface instead of raw pixel data, this function operates like SDL_LockTexture.

As an optimization, the pixels made available for editing don't necessarily contain the old texture data. This is a write-only operation, and if you need to keep a copy of the texture data you should do that at the application level.

You must use SDL_UnlockTexture() to unlock the pixels and apply any changes.

The returned surface is freed internally after calling SDL_UnlockTexture() or SDL_DestroyTexture(). The caller should not free it.

Parameters

  texture | the texture to lock for access, which must be created with `SDL_TEXTUREACCESS_STREAMING`.
  rect | a pointer to the rectangle to lock for access. If the rect is NULL, the entire texture will be locked.
  surface | a pointer to an SDL surface of size rect. Don't assume any specific pixel content.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_LockTexture
  SDL_UnlockTexture

## SDL_RenderClear()

bool SDL_RenderClear | ( | SDL_Renderer * | renderer | ) |

extern

Clear the current rendering target with the drawing color.

This function clears the entire rendering target, ignoring the viewport and the clip rectangle. Note, that clearing will also set/fill all pixels of the rendering target to current renderer draw color, so make sure to invoke SDL_SetRenderDrawColor() when needed.

Parameters

  renderer | the rendering context.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_SetRenderDrawColor

Referenced by SDL_AppIterate().

## SDL_RenderClipEnabled()

bool SDL_RenderClipEnabled | ( | SDL_Renderer * | renderer | ) |

extern

Get whether clipping is enabled on the given render target.

Each render target has its own clip rectangle. This function checks the cliprect for the current render target.

Parameters

  renderer | the rendering context.

Returns
  true if clipping is enabled or false if not; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetRenderClipRect
  SDL_SetRenderClipRect

## SDL_RenderCoordinatesFromWindow()

bool SDL_RenderCoordinatesFromWindow | ( | SDL_Renderer * | renderer,
|  | float | window_x,
|  | float | window_y,
|  | float * | x,
|  | float * | y
| ) |  |

extern

Get a point in render coordinates when given a point in window coordinates.

This takes into account several states:

- The window dimensions.
- The logical presentation settings (SDL_SetRenderLogicalPresentation)
- The scale (SDL_SetRenderScale)
- The viewport (SDL_SetRenderViewport)

Parameters

  renderer | the rendering context.
  window_x | the x coordinate in window coordinates.
  window_y | the y coordinate in window coordinates.
  x | a pointer filled with the x coordinate in render coordinates.
  y | a pointer filled with the y coordinate in render coordinates.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_SetRenderLogicalPresentation
  SDL_SetRenderScale

## SDL_RenderCoordinatesToWindow()

bool SDL_RenderCoordinatesToWindow | ( | SDL_Renderer * | renderer,
|  | float | x,
|  | float | y,
|  | float * | window_x,
|  | float * | window_y
| ) |  |

extern

Get a point in window coordinates when given a point in render coordinates.

This takes into account several states:

- The window dimensions.
- The logical presentation settings (SDL_SetRenderLogicalPresentation)
- The scale (SDL_SetRenderScale)
- The viewport (SDL_SetRenderViewport)

Parameters

  renderer | the rendering context.
  x | the x coordinate in render coordinates.
  y | the y coordinate in render coordinates.
  window_x | a pointer filled with the x coordinate in window coordinates.
  window_y | a pointer filled with the y coordinate in window coordinates.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_SetRenderLogicalPresentation
  SDL_SetRenderScale
  SDL_SetRenderViewport

## SDL_RenderDebugText()

bool SDL_RenderDebugText | ( | SDL_Renderer * | renderer,
|  | float | x,
|  | float | y,
|  | const char * | str
| ) |  |

extern

Draw debug text to an SDL_Renderer.

This function will render a string of text to an SDL_Renderer. Note that this is a convenience function for debugging, with severe limitations, and not intended to be used for production apps and games.

Among these limitations:

- It accepts UTF-8 strings, but will only renders ASCII characters.
- It has a single, tiny size (8x8 pixels). One can use logical presentation or scaling to adjust it, but it will be blurry.
- It uses a simple, hardcoded bitmap font. It does not allow different font selections and it does not support truetype, for proper scaling.
- It does no word-wrapping and does not treat newline characters as a line break. If the text goes out of the window, it's gone.

For serious text rendering, there are several good options, such as SDL_ttf, stb_truetype, or other external libraries.

On first use, this will create an internal texture for rendering glyphs. This texture will live until the renderer is destroyed.

The text is drawn in the color specified by SDL_SetRenderDrawColor().

Parameters

  renderer | the renderer which should draw a line of text.
  x | the x coordinate where the top-left corner of the text will draw.
  y | the y coordinate where the top-left corner of the text will draw.
  str | the string to render.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_RenderDebugTextFormat
  SDL_DEBUG_TEXT_FONT_CHARACTER_SIZE

Referenced by SDL_AppIterate().

## SDL_RenderDebugTextFormat()

bool SDL_RenderDebugTextFormat | ( | SDL_Renderer * | renderer,
|  | float | x,
|  | float | y,
|  | SDL_PRINTF_FORMAT_STRING const char * | fmt,
|  |  | ...
| ) |  |

extern

Draw debug text to an SDL_Renderer.

This function will render a printf()-style format string to a renderer. Note that this is a convinence function for debugging, with severe limitations, and is not intended to be used for production apps and games.

For the full list of limitations and other useful information, see SDL_RenderDebugText.

Parameters

  renderer | the renderer which should draw the text.
  x | the x coordinate where the top-left corner of the text will draw.
  y | the y coordinate where the top-left corner of the text will draw.
  fmt | the format string to draw.
  ... | additional parameters matching % tokens in the `fmt` string, if any.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_RenderDebugText
  SDL_DEBUG_TEXT_FONT_CHARACTER_SIZE

## SDL_RenderFillRect()

bool SDL_RenderFillRect | ( | SDL_Renderer * | renderer,
|  | const SDL_FRect * | rect
| ) |  |

extern

Fill a rectangle on the current rendering target with the drawing color at subpixel precision.

Parameters

  renderer | the renderer which should fill a rectangle.
  rect | a pointer to the destination rectangle, or NULL for the entire rendering target.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_RenderFillRects

## SDL_RenderFillRects()

bool SDL_RenderFillRects | ( | SDL_Renderer * | renderer,
|  | const SDL_FRect * | rects,
|  | int | count
| ) |  |

extern

Fill some number of rectangles on the current rendering target with the drawing color at subpixel precision.

Parameters

  renderer | the renderer which should fill multiple rectangles.
  rects | a pointer to an array of destination rectangles.
  count | the number of rectangles.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_RenderFillRect

## SDL_RenderGeometry()

bool SDL_RenderGeometry | ( | SDL_Renderer * | renderer,
|  | SDL_Texture * | texture,
|  | const SDL_Vertex * | vertices,
|  | int | num_vertices,
|  | const int * | indices,
|  | int | num_indices
| ) |  |

extern

Render a list of triangles, optionally using a texture and indices into the vertex array Color and alpha modulation is done per vertex (SDL_SetTextureColorMod and SDL_SetTextureAlphaMod are ignored).

Parameters

  renderer | the rendering context.
  texture | (optional) The SDL texture to use.
  vertices | vertices.
  num_vertices | number of vertices.
  indices | (optional) An array of integer indices into the 'vertices' array, if NULL all vertices will be rendered in sequential order.
  num_indices | number of indices.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_RenderGeometryRaw

## SDL_RenderGeometryRaw()

bool SDL_RenderGeometryRaw | ( | SDL_Renderer * | renderer,
|  | SDL_Texture * | texture,
|  | const float * | xy,
|  | int | xy_stride,
|  | const SDL_FColor * | color,
|  | int | color_stride,
|  | const float * | uv,
|  | int | uv_stride,
|  | int | num_vertices,
|  | const void * | indices,
|  | int | num_indices,
|  | int | size_indices
| ) |  |

extern

Render a list of triangles, optionally using a texture and indices into the vertex arrays Color and alpha modulation is done per vertex (SDL_SetTextureColorMod and SDL_SetTextureAlphaMod are ignored).

Parameters

  renderer | the rendering context.
  texture | (optional) The SDL texture to use.
  xy | vertex positions.
  xy_stride | byte size to move from one element to the next element.
  color | vertex colors (as SDL_FColor).
  color_stride | byte size to move from one element to the next element.
  uv | vertex normalized texture coordinates.
  uv_stride | byte size to move from one element to the next element.
  num_vertices | number of vertices.
  indices | (optional) An array of indices into the 'vertices' arrays, if NULL all vertices will be rendered in sequential order.
  num_indices | number of indices.
  size_indices | index size: 1 (byte), 2 (short), 4 (int).

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_RenderGeometry

## SDL_RenderLine()

bool SDL_RenderLine | ( | SDL_Renderer * | renderer,
|  | float | x1,
|  | float | y1,
|  | float | x2,
|  | float | y2
| ) |  |

extern

Draw a line on the current rendering target at subpixel precision.

Parameters

  renderer | the renderer which should draw a line.
  x1 | the x coordinate of the start point.
  y1 | the y coordinate of the start point.
  x2 | the x coordinate of the end point.
  y2 | the y coordinate of the end point.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_RenderLines

## SDL_RenderLines()

bool SDL_RenderLines | ( | SDL_Renderer * | renderer,
|  | const SDL_FPoint * | points,
|  | int | count
| ) |  |

extern

Draw a series of connected lines on the current rendering target at subpixel precision.

Parameters

  renderer | the renderer which should draw multiple lines.
  points | the points along the lines.
  count | the number of points, drawing count-1 lines.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_RenderLine

## SDL_RenderPoint()

bool SDL_RenderPoint | ( | SDL_Renderer * | renderer,
|  | float | x,
|  | float | y
| ) |  |

extern

Draw a point on the current rendering target at subpixel precision.

Parameters

  renderer | the renderer which should draw a point.
  x | the x coordinate of the point.
  y | the y coordinate of the point.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_RenderPoints

## SDL_RenderPoints()

bool SDL_RenderPoints | ( | SDL_Renderer * | renderer,
|  | const SDL_FPoint * | points,
|  | int | count
| ) |  |

extern

Draw multiple points on the current rendering target at subpixel precision.

Parameters

  renderer | the renderer which should draw multiple points.
  points | the points to draw.
  count | the number of points to draw.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_RenderPoint

## SDL_RenderPresent()

bool SDL_RenderPresent | ( | SDL_Renderer * | renderer | ) |

extern

Update the screen with any rendering performed since the previous call.

SDL's rendering functions operate on a backbuffer; that is, calling a rendering function such as SDL_RenderLine() does not directly put a line on the screen, but rather updates the backbuffer. As such, you compose your entire scene and present the composed backbuffer to the screen as a complete picture.

Therefore, when using SDL's rendering API, one does all drawing intended for the frame, and then calls this function once per frame to present the final drawing to the user.

The backbuffer should be considered invalidated after each present; do not assume that previous contents will exist between frames. You are strongly encouraged to call SDL_RenderClear() to initialize the backbuffer before starting each new frame's drawing, even if you plan to overwrite every pixel.

Please note, that in case of rendering to a texture - there is no need to call `SDL_RenderPresent` after drawing needed objects to a texture, and should not be done; you are only required to change back the rendering target to default via `SDL_SetRenderTarget(renderer, NULL)` afterwards, as textures by themselves do not have a concept of backbuffers. Calling SDL_RenderPresent while rendering to a texture will still update the screen with any current drawing that has been done to the window itself.

Parameters

  renderer | the rendering context.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_CreateRenderer
  SDL_RenderClear
  SDL_RenderFillRect
  SDL_RenderFillRects
  SDL_RenderLine
  SDL_RenderLines
  SDL_RenderPoint
  SDL_RenderPoints
  SDL_RenderRect
  SDL_RenderRects
  SDL_SetRenderDrawBlendMode
  SDL_SetRenderDrawColor

Referenced by SDL_AppIterate().

## SDL_RenderReadPixels()

SDL_Surface * SDL_RenderReadPixels | ( | SDL_Renderer * | renderer,
|  | const SDL_Rect * | rect
| ) |  |

extern

Read pixels from the current rendering target.

The returned surface contains pixels inside the desired area clipped to the current viewport, and should be freed with SDL_DestroySurface().

Note that this returns the actual pixels on the screen, so if you are using logical presentation you should use SDL_GetRenderLogicalPresentationRect() to get the area containing your content.

WARNING: This is a very slow operation, and should not be used frequently. If you're using this on the main rendering target, it should be called after rendering and before SDL_RenderPresent().

Parameters

  renderer | the rendering context.
  rect | an SDL_Rect structure representing the area to read, which will be clipped to the current viewport, or NULL for the entire viewport.

Returns
  a new SDL_Surface on success or NULL on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

## SDL_RenderRect()

bool SDL_RenderRect | ( | SDL_Renderer * | renderer,
|  | const SDL_FRect * | rect
| ) |  |

extern

Draw a rectangle on the current rendering target at subpixel precision.

Parameters

  renderer | the renderer which should draw a rectangle.
  rect | a pointer to the destination rectangle, or NULL to outline the entire rendering target.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_RenderRects

## SDL_RenderRects()

bool SDL_RenderRects | ( | SDL_Renderer * | renderer,
|  | const SDL_FRect * | rects,
|  | int | count
| ) |  |

extern

Draw some number of rectangles on the current rendering target at subpixel precision.

Parameters

  renderer | the renderer which should draw multiple rectangles.
  rects | a pointer to an array of destination rectangles.
  count | the number of rectangles.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_RenderRect

## SDL_RenderTexture()

bool SDL_RenderTexture | ( | SDL_Renderer * | renderer,
|  | SDL_Texture * | texture,
|  | const SDL_FRect * | srcrect,
|  | const SDL_FRect * | dstrect
| ) |  |

extern

Copy a portion of the texture to the current rendering target at subpixel precision.

Parameters

  renderer | the renderer which should copy parts of a texture.
  texture | the source texture.
  srcrect | a pointer to the source rectangle, or NULL for the entire texture.
  dstrect | a pointer to the destination rectangle, or NULL for the entire rendering target.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_RenderTextureRotated
  SDL_RenderTextureTiled

## SDL_RenderTexture9Grid()

bool SDL_RenderTexture9Grid | ( | SDL_Renderer * | renderer,
|  | SDL_Texture * | texture,
|  | const SDL_FRect * | srcrect,
|  | float | left_width,
|  | float | right_width,
|  | float | top_height,
|  | float | bottom_height,
|  | float | scale,
|  | const SDL_FRect * | dstrect
| ) |  |

extern

Perform a scaled copy using the 9-grid algorithm to the current rendering target at subpixel precision.

The pixels in the texture are split into a 3x3 grid, using the different corner sizes for each corner, and the sides and center making up the remaining pixels. The corners are then scaled using `scale` and fit into the corners of the destination rectangle. The sides and center are then stretched into place to cover the remaining destination rectangle.

Parameters

  renderer | the renderer which should copy parts of a texture.
  texture | the source texture.
  srcrect | the SDL_Rect structure representing the rectangle to be used for the 9-grid, or NULL to use the entire texture.
  left_width | the width, in pixels, of the left corners in `srcrect`.
  right_width | the width, in pixels, of the right corners in `srcrect`.
  top_height | the height, in pixels, of the top corners in `srcrect`.
  bottom_height | the height, in pixels, of the bottom corners in `srcrect`.
  scale | the scale used to transform the corner of `srcrect` into the corner of `dstrect`, or 0.0f for an unscaled copy.
  dstrect | a pointer to the destination rectangle, or NULL for the entire rendering target.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_RenderTexture

## SDL_RenderTextureAffine()

bool SDL_RenderTextureAffine | ( | SDL_Renderer * | renderer,
|  | SDL_Texture * | texture,
|  | const SDL_FRect * | srcrect,
|  | const SDL_FPoint * | origin,
|  | const SDL_FPoint * | right,
|  | const SDL_FPoint * | down
| ) |  |

extern

Copy a portion of the source texture to the current rendering target, with affine transform, at subpixel precision.

Parameters

  renderer | the renderer which should copy parts of a texture.
  texture | the source texture.
  srcrect | a pointer to the source rectangle, or NULL for the entire texture.
  origin | a pointer to a point indicating where the top-left corner of srcrect should be mapped to, or NULL for the rendering target's origin.
  right | a pointer to a point indicating where the top-right corner of srcrect should be mapped to, or NULL for the rendering target's top-right corner.
  down | a pointer to a point indicating where the bottom-left corner of srcrect should be mapped to, or NULL for the rendering target's bottom-left corner.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety You may only call this function from the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_RenderTexture

## SDL_RenderTextureRotated()

bool SDL_RenderTextureRotated | ( | SDL_Renderer * | renderer,
|  | SDL_Texture * | texture,
|  | const SDL_FRect * | srcrect,
|  | const SDL_FRect * | dstrect,
|  | double | angle,
|  | const SDL_FPoint * | center,
|  | SDL_FlipMode | flip
| ) |  |

extern

Copy a portion of the source texture to the current rendering target, with rotation and flipping, at subpixel precision.

Parameters

  renderer | the renderer which should copy parts of a texture.
  texture | the source texture.
  srcrect | a pointer to the source rectangle, or NULL for the entire texture.
  dstrect | a pointer to the destination rectangle, or NULL for the entire rendering target.
  angle | an angle in degrees that indicates the rotation that will be applied to dstrect, rotating it in a clockwise direction.
  center | a pointer to a point indicating the point around which dstrect will be rotated (if NULL, rotation will be done around dstrect.w/2, dstrect.h/2).
  flip | an SDL_FlipMode value stating which flipping actions should be performed on the texture.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_RenderTexture

## SDL_RenderTextureTiled()

bool SDL_RenderTextureTiled | ( | SDL_Renderer * | renderer,
|  | SDL_Texture * | texture,
|  | const SDL_FRect * | srcrect,
|  | float | scale,
|  | const SDL_FRect * | dstrect
| ) |  |

extern

Tile a portion of the texture to the current rendering target at subpixel precision.

The pixels in `srcrect` will be repeated as many times as needed to completely fill `dstrect`.

Parameters

  renderer | the renderer which should copy parts of a texture.
  texture | the source texture.
  srcrect | a pointer to the source rectangle, or NULL for the entire texture.
  scale | the scale used to transform srcrect into the destination rectangle, e.g. a 32x32 texture with a scale of 2 would fill 64x64 tiles.
  dstrect | a pointer to the destination rectangle, or NULL for the entire rendering target.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_RenderTexture

## SDL_RenderViewportSet()

bool SDL_RenderViewportSet | ( | SDL_Renderer * | renderer | ) |

extern

Return whether an explicit rectangle was set as the viewport.

This is useful if you're saving and restoring the viewport and want to know whether you should restore a specific rectangle or NULL.

Each render target has its own viewport. This function checks the viewport for the current render target.

Parameters

  renderer | the rendering context.

Returns
  true if the viewport was set to a specific rectangle, or false if it was set to NULL (the entire target).

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetRenderViewport
  SDL_SetRenderViewport

## SDL_SetRenderClipRect()

bool SDL_SetRenderClipRect | ( | SDL_Renderer * | renderer,
|  | const SDL_Rect * | rect
| ) |  |

extern

Set the clip rectangle for rendering on the specified target.

Each render target has its own clip rectangle. This function sets the cliprect for the current render target.

Parameters

  renderer | the rendering context.
  rect | an SDL_Rect structure representing the clip area, relative to the viewport, or NULL to disable clipping.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetRenderClipRect
  SDL_RenderClipEnabled

## SDL_SetRenderColorScale()

bool SDL_SetRenderColorScale | ( | SDL_Renderer * | renderer,
|  | float | scale
| ) |  |

extern

Set the color scale used for render operations.

The color scale is an additional scale multiplied into the pixel color value while rendering. This can be used to adjust the brightness of colors during HDR rendering, or changing HDR video brightness when playing on an SDR display.

The color scale does not affect the alpha channel, only the color brightness.

Parameters

  renderer | the rendering context.
  scale | the color scale value.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetRenderColorScale

## SDL_SetRenderDrawBlendMode()

bool SDL_SetRenderDrawBlendMode | ( | SDL_Renderer * | renderer,
|  | SDL_BlendMode | blendMode
| ) |  |

extern

Set the blend mode used for drawing operations (Fill and Line).

If the blend mode is not supported, the closest supported mode is chosen.

Parameters

  renderer | the rendering context.
  blendMode | the SDL_BlendMode to use for blending.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetRenderDrawBlendMode

## SDL_SetRenderDrawColor()

bool SDL_SetRenderDrawColor | ( | SDL_Renderer * | renderer,
|  | Uint8 | r,
|  | Uint8 | g,
|  | Uint8 | b,
|  | Uint8 | a
| ) |  |

extern

Set the color used for drawing operations.

Set the color for drawing or filling rectangles, lines, and points, and for SDL_RenderClear().

Parameters

  renderer | the rendering context.
  r | the red value used to draw on the rendering target.
  g | the green value used to draw on the rendering target.
  b | the blue value used to draw on the rendering target.
  a | the alpha value used to draw on the rendering target; usually `SDL_ALPHA_OPAQUE` (255). Use SDL_SetRenderDrawBlendMode to specify how the alpha channel is used.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetRenderDrawColor
  SDL_SetRenderDrawColorFloat

Referenced by SDL_AppIterate().

## SDL_SetRenderDrawColorFloat()

bool SDL_SetRenderDrawColorFloat | ( | SDL_Renderer * | renderer,
|  | float | r,
|  | float | g,
|  | float | b,
|  | float | a
| ) |  |

extern

Set the color used for drawing operations (Rect, Line and Clear).

Set the color for drawing or filling rectangles, lines, and points, and for SDL_RenderClear().

Parameters

  renderer | the rendering context.
  r | the red value used to draw on the rendering target.
  g | the green value used to draw on the rendering target.
  b | the blue value used to draw on the rendering target.
  a | the alpha value used to draw on the rendering target. Use SDL_SetRenderDrawBlendMode to specify how the alpha channel is used.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetRenderDrawColorFloat
  SDL_SetRenderDrawColor

## SDL_SetRenderLogicalPresentation()

bool SDL_SetRenderLogicalPresentation | ( | SDL_Renderer * | renderer,
|  | int | w,
|  | int | h,
|  | SDL_RendererLogicalPresentation | mode
| ) |  |

extern

Set a device-independent resolution and presentation mode for rendering.

This function sets the width and height of the logical rendering output. The renderer will act as if the current render target is always the requested dimensions, scaling to the actual resolution as necessary.

This can be useful for games that expect a fixed size, but would like to scale the output to whatever is available, regardless of how a user resizes a window, or if the display is high DPI.

Logical presentation can be used with both render target textures and the renderer's window; the state is unique to each render target, and this function sets the state for the current render target. It might be useful to draw to a texture that matches the window dimensions with logical presentation enabled, and then draw that texture across the entire window with logical presentation disabled. Be careful not to render both with logical presentation enabled, however, as this could produce double-letterboxing, etc.

You can disable logical coordinates by setting the mode to SDL_LOGICAL_PRESENTATION_DISABLED, and in that case you get the full pixel resolution of the render target; it is safe to toggle logical presentation during the rendering of a frame: perhaps most of the rendering is done to specific dimensions but to make fonts look sharp, the app turns off logical presentation while drawing text, for example.

For the renderer's window, letterboxing is drawn into the framebuffer if logical presentation is enabled during SDL_RenderPresent; be sure to reenable it before presenting if you were toggling it, otherwise the letterbox areas might have artifacts from previous frames (or artifacts from external overlays, etc). Letterboxing is never drawn into texture render targets; be sure to call SDL_RenderClear() before drawing into the texture so the letterboxing areas are cleared, if appropriate.

You can convert coordinates in an event into rendering coordinates using SDL_ConvertEventToRenderCoordinates().

Parameters

  renderer | the rendering context.
  w | the width of the logical resolution.
  h | the height of the logical resolution.
  mode | the presentation mode used.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_ConvertEventToRenderCoordinates
  SDL_GetRenderLogicalPresentation
  SDL_GetRenderLogicalPresentationRect

## SDL_SetRenderScale()

bool SDL_SetRenderScale | ( | SDL_Renderer * | renderer,
|  | float | scaleX,
|  | float | scaleY
| ) |  |

extern

Set the drawing scale for rendering on the current target.

The drawing coordinates are scaled by the x/y scaling factors before they are used by the renderer. This allows resolution independent drawing with a single coordinate system.

If this results in scaling or subpixel drawing by the rendering backend, it will be handled using the appropriate quality hints. For best results use integer scaling factors.

Each render target has its own scale. This function sets the scale for the current render target.

Parameters

  renderer | the rendering context.
  scaleX | the horizontal scaling factor.
  scaleY | the vertical scaling factor.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetRenderScale

Referenced by SDL_AppIterate().

## SDL_SetRenderTarget()

bool SDL_SetRenderTarget | ( | SDL_Renderer * | renderer,
|  | SDL_Texture * | texture
| ) |  |

extern

Set a texture as the current rendering target.

The default render target is the window for which the renderer was created. To stop rendering to a texture and render to the window again, call this function with a NULL `texture`.

Viewport, cliprect, scale, and logical presentation are unique to each render target. Get and set functions for these states apply to the current render target set by this function, and those states persist on each target when the current render target changes.

Parameters

  renderer | the rendering context.
  texture | the targeted texture, which must be created with the `SDL_TEXTUREACCESS_TARGET` flag, or NULL to render to the window instead of a texture.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetRenderTarget

## SDL_SetRenderViewport()

bool SDL_SetRenderViewport | ( | SDL_Renderer * | renderer,
|  | const SDL_Rect * | rect
| ) |  |

extern

Set the drawing area for rendering on the current target.

Drawing will clip to this area (separately from any clipping done with SDL_SetRenderClipRect), and the top left of the area will become coordinate (0, 0) for future drawing commands.

The area's width and height must be >= 0.

Each render target has its own viewport. This function sets the viewport for the current render target.

Parameters

  renderer | the rendering context.
  rect | the SDL_Rect structure representing the drawing area, or NULL to set the viewport to the entire target.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetRenderViewport
  SDL_RenderViewportSet

## SDL_SetRenderVSync()

bool SDL_SetRenderVSync | ( | SDL_Renderer * | renderer,
|  | int | vsync
| ) |  |

extern

Toggle VSync of the given renderer.

When a renderer is created, vsync defaults to SDL_RENDERER_VSYNC_DISABLED.

The `vsync` parameter can be 1 to synchronize present with every vertical refresh, 2 to synchronize present with every second vertical refresh, etc., SDL_RENDERER_VSYNC_ADAPTIVE for late swap tearing (adaptive vsync), or SDL_RENDERER_VSYNC_DISABLED to disable. Not every value is supported by every driver, so you should check the return value to see whether the requested setting is supported.

Parameters

  renderer | the renderer to toggle.
  vsync | the vertical refresh sync interval.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetRenderVSync

## SDL_SetTextureAlphaMod()

bool SDL_SetTextureAlphaMod | ( | SDL_Texture * | texture,
|  | Uint8 | alpha
| ) |  |

extern

Set an additional alpha value multiplied into render copy operations.

When this texture is rendered, during the copy operation the source alpha value is modulated by this alpha value according to the following formula:

`srcA = srcA * (alpha / 255)`

Alpha modulation is not always supported by the renderer; it will return false if alpha modulation is not supported.

Parameters

  texture | the texture to update.
  alpha | the source alpha value multiplied into copy operations.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetTextureAlphaMod
  SDL_SetTextureAlphaModFloat
  SDL_SetTextureColorMod

## SDL_SetTextureAlphaModFloat()

bool SDL_SetTextureAlphaModFloat | ( | SDL_Texture * | texture,
|  | float | alpha
| ) |  |

extern

Set an additional alpha value multiplied into render copy operations.

When this texture is rendered, during the copy operation the source alpha value is modulated by this alpha value according to the following formula:

`srcA = srcA * alpha`

Alpha modulation is not always supported by the renderer; it will return false if alpha modulation is not supported.

Parameters

  texture | the texture to update.
  alpha | the source alpha value multiplied into copy operations.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetTextureAlphaModFloat
  SDL_SetTextureAlphaMod
  SDL_SetTextureColorModFloat

## SDL_SetTextureBlendMode()

bool SDL_SetTextureBlendMode | ( | SDL_Texture * | texture,
|  | SDL_BlendMode | blendMode
| ) |  |

extern

Set the blend mode for a texture, used by SDL_RenderTexture().

If the blend mode is not supported, the closest supported mode is chosen and this function returns false.

Parameters

  texture | the texture to update.
  blendMode | the SDL_BlendMode to use for texture blending.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetTextureBlendMode

## SDL_SetTextureColorMod()

bool SDL_SetTextureColorMod | ( | SDL_Texture * | texture,
|  | Uint8 | r,
|  | Uint8 | g,
|  | Uint8 | b
| ) |  |

extern

Set an additional color value multiplied into render copy operations.

When this texture is rendered, during the copy operation each source color channel is modulated by the appropriate color value according to the following formula:

`srcC = srcC * (color / 255)`

Color modulation is not always supported by the renderer; it will return false if color modulation is not supported.

Parameters

  texture | the texture to update.
  r | the red color value multiplied into copy operations.
  g | the green color value multiplied into copy operations.
  b | the blue color value multiplied into copy operations.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetTextureColorMod
  SDL_SetTextureAlphaMod
  SDL_SetTextureColorModFloat

## SDL_SetTextureColorModFloat()

bool SDL_SetTextureColorModFloat | ( | SDL_Texture * | texture,
|  | float | r,
|  | float | g,
|  | float | b
| ) |  |

extern

Set an additional color value multiplied into render copy operations.

When this texture is rendered, during the copy operation each source color channel is modulated by the appropriate color value according to the following formula:

`srcC = srcC * color`

Color modulation is not always supported by the renderer; it will return false if color modulation is not supported.

Parameters

  texture | the texture to update.
  r | the red color value multiplied into copy operations.
  g | the green color value multiplied into copy operations.
  b | the blue color value multiplied into copy operations.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetTextureColorModFloat
  SDL_SetTextureAlphaModFloat
  SDL_SetTextureColorMod

## SDL_SetTextureScaleMode()

bool SDL_SetTextureScaleMode | ( | SDL_Texture * | texture,
|  | SDL_ScaleMode | scaleMode
| ) |  |

extern

Set the scale mode used for texture scale operations.

The default texture scale mode is SDL_SCALEMODE_LINEAR.

If the scale mode is not supported, the closest supported mode is chosen.

Parameters

  texture | the texture to update.
  scaleMode | the SDL_ScaleMode to use for texture scaling.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetTextureScaleMode

## SDL_UnlockTexture()

void SDL_UnlockTexture | ( | SDL_Texture * | texture | ) |

extern

Unlock a texture, uploading the changes to video memory, if needed.

Warning: Please note that SDL_LockTexture() is intended to be write-only; it will not guarantee the previous contents of the texture will be provided. You must fully initialize any area of a texture that you lock before unlocking it, as the pixels might otherwise be uninitialized memory.

Which is to say: locking and immediately unlocking a texture can result in corrupted textures, depending on the renderer in use.

Parameters

  texture | a texture locked by SDL_LockTexture().

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_LockTexture

## SDL_UpdateNVTexture()

bool SDL_UpdateNVTexture | ( | SDL_Texture * | texture,
|  | const SDL_Rect * | rect,
|  | const Uint8 * | Yplane,
|  | int | Ypitch,
|  | const Uint8 * | UVplane,
|  | int | UVpitch
| ) |  |

extern

Update a rectangle within a planar NV12 or NV21 texture with new pixels.

You can use SDL_UpdateTexture() as long as your pixel data is a contiguous block of NV12/21 planes in the proper order, but this function is available if your pixel data is not contiguous.

Parameters

  texture | the texture to update.
  rect | a pointer to the rectangle of pixels to update, or NULL to update the entire texture.
  Yplane | the raw pixel data for the Y plane.
  Ypitch | the number of bytes between rows of pixel data for the Y plane.
  UVplane | the raw pixel data for the UV plane.
  UVpitch | the number of bytes between rows of pixel data for the UV plane.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_UpdateTexture
  SDL_UpdateYUVTexture

## SDL_UpdateTexture()

bool SDL_UpdateTexture | ( | SDL_Texture * | texture,
|  | const SDL_Rect * | rect,
|  | const void * | pixels,
|  | int | pitch
| ) |  |

extern

Update the given texture rectangle with new pixel data.

The pixel data must be in the pixel format of the texture, which can be queried using the SDL_PROP_TEXTURE_FORMAT_NUMBER property.

This is a fairly slow function, intended for use with static textures that do not change often.

If the texture is intended to be updated often, it is preferred to create the texture as streaming and use the locking functions referenced below. While this function will work with streaming textures, for optimization reasons you may not get the pixels back if you lock the texture afterward.

Parameters

  texture | the texture to update.
  rect | an SDL_Rect structure representing the area to update, or NULL to update the entire texture.
  pixels | the raw pixel data in the format of the texture.
  pitch | the number of bytes in a row of pixel data, including padding between lines.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_LockTexture
  SDL_UnlockTexture
  SDL_UpdateNVTexture
  SDL_UpdateYUVTexture

## SDL_UpdateYUVTexture()

bool SDL_UpdateYUVTexture | ( | SDL_Texture * | texture,
|  | const SDL_Rect * | rect,
|  | const Uint8 * | Yplane,
|  | int | Ypitch,
|  | const Uint8 * | Uplane,
|  | int | Upitch,
|  | const Uint8 * | Vplane,
|  | int | Vpitch
| ) |  |

extern

Update a rectangle within a planar YV12 or IYUV texture with new pixel data.

You can use SDL_UpdateTexture() as long as your pixel data is a contiguous block of Y and U/V planes in the proper order, but this function is available if your pixel data is not contiguous.

Parameters

  texture | the texture to update.
  rect | a pointer to the rectangle of pixels to update, or NULL to update the entire texture.
  Yplane | the raw pixel data for the Y plane.
  Ypitch | the number of bytes between rows of pixel data for the Y plane.
  Uplane | the raw pixel data for the U plane.
  Upitch | the number of bytes between rows of pixel data for the U plane.
  Vplane | the raw pixel data for the V plane.
  Vpitch | the number of bytes between rows of pixel data for the V plane.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_UpdateNVTexture
  SDL_UpdateTexture